/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         CISAparse
#define yylex           CISAlex
#define yyerror         CISAerror
#define yydebug         CISAdebug
#define yynerrs         CISAnerrs
#define yylval          CISAlval
#define yychar          CISAchar

/* First part of user prologue.  */
#line 9 "CISA.y"

#include <stdio.h>
#include <math.h>
#include <string>
#include <vector>

#include "visa_igc_common_header.h"
#include "Common_ISA.h"
#include "Common_ISA_util.h"
#include "Common_ISA_framework.h"
#include "JitterDataStruct.h"
#include "VISAKernel.h"

static int lscCheckExecSize(
    CISA_IR_Builder* pBuilder,
    LSC_SFID sfid,
    LSC_OP op,
    LSC_DATA_ORDER data_order,
    int exec_size);

//VISA_Type variable_declaration_and_type_check(char *var, Common_ISA_Var_Class type);
void CISAerror(CISA_IR_Builder* builder, char const* msg);
int yylex(CISA_IR_Builder *pBuilder);
extern int CISAlineno;


static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value);
static VISA_Align AlignBytesToVisaAlignment(int bytes);
static int DataTypeSizeOf(VISA_Type type);
static bool ParseEMask(const char* sym, VISA_EMask_Ctrl &emask);




//
// check if the cond is true.
// if cond is false, then print errorMessage (syntax error) and YYABORT
#define MUST_HOLD(cond, errorMessage) \
  {if (!(cond)) {pBuilder->RecordParseError(CISAlineno, errorMessage); YYABORT;}}
#define PARSE_ERROR_AT(LINE,...)\
  {pBuilder->RecordParseError(LINE, __VA_ARGS__); YYABORT;}
#define PARSE_ERROR(...)\
    PARSE_ERROR_AT(CISAlineno, __VA_ARGS__)

// Use this to wrap API calls that return false, nullptr, or 0 on failure
// It's assumed that the API call reported the parse error
#define ABORT_ON_FAIL(X) \
    do \
        if (!(X)) \
            YYABORT;\
    while (0)
#define TRACE(S) \
    do { \
      if (CISAout && pBuilder->debugParse()) \
          fprintf(CISAout, "line %d: %s", CISAlineno, S); \
    } while (0)

std::deque<const char*> switchLabels;
char * switch_label_array[32];
std::vector<VISA_opnd*> RTRWOperands;
int num_parameters;

VISA_RawOpnd* rawOperandArray[16];

// global var for non-kernel attribute option.
// The var needs to be cleared before each use.
std::vector<attr_gen_struct*> AttrOptVar;

#ifdef _MSC_VER
#pragma warning(disable:4065; disable:4267)
#endif


#line 152 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "CISA.tab.hpp"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ALIGN_KEYWORD = 3,              /* ALIGN_KEYWORD  */
  YYSYMBOL_ATOMIC_SUB_OP = 4,              /* ATOMIC_SUB_OP  */
  YYSYMBOL_DIRECTIVE_DECL = 5,             /* DIRECTIVE_DECL  */
  YYSYMBOL_DIRECTIVE_FUNC = 6,             /* DIRECTIVE_FUNC  */
  YYSYMBOL_DIRECTIVE_FUNCDECL = 7,         /* DIRECTIVE_FUNCDECL  */
  YYSYMBOL_DIRECTIVE_GLOBAL_FUNC = 8,      /* DIRECTIVE_GLOBAL_FUNC  */
  YYSYMBOL_DIRECTIVE_IMPLICIT = 9,         /* DIRECTIVE_IMPLICIT  */
  YYSYMBOL_DIRECTIVE_INPUT = 10,           /* DIRECTIVE_INPUT  */
  YYSYMBOL_DIRECTIVE_KERNEL = 11,          /* DIRECTIVE_KERNEL  */
  YYSYMBOL_DIRECTIVE_KERNEL_ATTR = 12,     /* DIRECTIVE_KERNEL_ATTR  */
  YYSYMBOL_DIRECTIVE_PARAMETER = 13,       /* DIRECTIVE_PARAMETER  */
  YYSYMBOL_DIRECTIVE_VERSION = 14,         /* DIRECTIVE_VERSION  */
  YYSYMBOL_ALIAS_EQ = 15,                  /* ALIAS_EQ  */
  YYSYMBOL_ALIGN_EQ = 16,                  /* ALIGN_EQ  */
  YYSYMBOL_ATTR_EQ = 17,                   /* ATTR_EQ  */
  YYSYMBOL_OFFSET_EQ = 18,                 /* OFFSET_EQ  */
  YYSYMBOL_NUM_ELTS_EQ = 19,               /* NUM_ELTS_EQ  */
  YYSYMBOL_V_NAME_EQ = 20,                 /* V_NAME_EQ  */
  YYSYMBOL_SIZE_EQ = 21,                   /* SIZE_EQ  */
  YYSYMBOL_V_TYPE_EQ_G = 22,               /* V_TYPE_EQ_G  */
  YYSYMBOL_V_TYPE_EQ_P = 23,               /* V_TYPE_EQ_P  */
  YYSYMBOL_V_TYPE_EQ_A = 24,               /* V_TYPE_EQ_A  */
  YYSYMBOL_V_TYPE_EQ_S = 25,               /* V_TYPE_EQ_S  */
  YYSYMBOL_V_TYPE_EQ_T = 26,               /* V_TYPE_EQ_T  */
  YYSYMBOL_CPS = 27,                       /* CPS  */
  YYSYMBOL_NON_UNIFORM_SAMPLER = 28,       /* NON_UNIFORM_SAMPLER  */
  YYSYMBOL_PIXEL_NULL_MASK = 29,           /* PIXEL_NULL_MASK  */
  YYSYMBOL_RAW_SENDC_STRING = 30,          /* RAW_SENDC_STRING  */
  YYSYMBOL_RAW_SENDSC_EOT_STRING = 31,     /* RAW_SENDSC_EOT_STRING  */
  YYSYMBOL_RAW_SENDSC_STRING = 32,         /* RAW_SENDSC_STRING  */
  YYSYMBOL_RAW_SENDS_EOT_STRING = 33,      /* RAW_SENDS_EOT_STRING  */
  YYSYMBOL_RAW_SENDS_STRING = 34,          /* RAW_SENDS_STRING  */
  YYSYMBOL_RAW_SEND_STRING = 35,           /* RAW_SEND_STRING  */
  YYSYMBOL_SAT = 36,                       /* SAT  */
  YYSYMBOL_SRCMOD_ABS = 37,                /* SRCMOD_ABS  */
  YYSYMBOL_SRCMOD_NEG = 38,                /* SRCMOD_NEG  */
  YYSYMBOL_SRCMOD_NEGABS = 39,             /* SRCMOD_NEGABS  */
  YYSYMBOL_SRCMOD_NOT = 40,                /* SRCMOD_NOT  */
  YYSYMBOL_BFN_OP = 41,                    /* BFN_OP  */
  YYSYMBOL_DPAS_OP = 42,                   /* DPAS_OP  */
  YYSYMBOL_BF_CVT_OP = 43,                 /* BF_CVT_OP  */
  YYSYMBOL_NBARRIER_SIGNAL = 44,           /* NBARRIER_SIGNAL  */
  YYSYMBOL_NBARRIER_WAIT = 45,             /* NBARRIER_WAIT  */
  YYSYMBOL_ITYPE = 46,                     /* ITYPE  */
  YYSYMBOL_DECL_DATA_TYPE = 47,            /* DECL_DATA_TYPE  */
  YYSYMBOL_DFTYPE = 48,                    /* DFTYPE  */
  YYSYMBOL_FTYPE = 49,                     /* FTYPE  */
  YYSYMBOL_HFTYPE = 50,                    /* HFTYPE  */
  YYSYMBOL_VTYPE = 51,                     /* VTYPE  */
  YYSYMBOL_COND_MOD = 52,                  /* COND_MOD  */
  YYSYMBOL_LANGLE = 53,                    /* LANGLE  */
  YYSYMBOL_RANGLE = 54,                    /* RANGLE  */
  YYSYMBOL_LBRACK = 55,                    /* LBRACK  */
  YYSYMBOL_RBRACK = 56,                    /* RBRACK  */
  YYSYMBOL_IND_LBRACK = 57,                /* IND_LBRACK  */
  YYSYMBOL_LPAREN = 58,                    /* LPAREN  */
  YYSYMBOL_RPAREN = 59,                    /* RPAREN  */
  YYSYMBOL_LBRACE = 60,                    /* LBRACE  */
  YYSYMBOL_RBRACE = 61,                    /* RBRACE  */
  YYSYMBOL_DOT = 62,                       /* DOT  */
  YYSYMBOL_COMMA = 63,                     /* COMMA  */
  YYSYMBOL_SEMI = 64,                      /* SEMI  */
  YYSYMBOL_COLON = 65,                     /* COLON  */
  YYSYMBOL_SLASH = 66,                     /* SLASH  */
  YYSYMBOL_PERCENT = 67,                   /* PERCENT  */
  YYSYMBOL_EQUALS = 68,                    /* EQUALS  */
  YYSYMBOL_PLUS = 69,                      /* PLUS  */
  YYSYMBOL_MINUS = 70,                     /* MINUS  */
  YYSYMBOL_TIMES = 71,                     /* TIMES  */
  YYSYMBOL_AMP = 72,                       /* AMP  */
  YYSYMBOL_CIRC = 73,                      /* CIRC  */
  YYSYMBOL_PIPE = 74,                      /* PIPE  */
  YYSYMBOL_TILDE = 75,                     /* TILDE  */
  YYSYMBOL_BANG = 76,                      /* BANG  */
  YYSYMBOL_QUESTION = 77,                  /* QUESTION  */
  YYSYMBOL_LEQ = 78,                       /* LEQ  */
  YYSYMBOL_GEQ = 79,                       /* GEQ  */
  YYSYMBOL_EQ = 80,                        /* EQ  */
  YYSYMBOL_NEQ = 81,                       /* NEQ  */
  YYSYMBOL_SHL = 82,                       /* SHL  */
  YYSYMBOL_SHRS = 83,                      /* SHRS  */
  YYSYMBOL_SHRZ = 84,                      /* SHRZ  */
  YYSYMBOL_LABEL = 85,                     /* LABEL  */
  YYSYMBOL_IDENT = 86,                     /* IDENT  */
  YYSYMBOL_BUILTIN_NULL = 87,              /* BUILTIN_NULL  */
  YYSYMBOL_BUILTIN = 88,                   /* BUILTIN  */
  YYSYMBOL_STRING_LIT = 89,                /* STRING_LIT  */
  YYSYMBOL_NEWLINE = 90,                   /* NEWLINE  */
  YYSYMBOL_RTWRITE_OPTION = 91,            /* RTWRITE_OPTION  */
  YYSYMBOL_MEDIA_MODE = 92,                /* MEDIA_MODE  */
  YYSYMBOL_OWORD_MODIFIER = 93,            /* OWORD_MODIFIER  */
  YYSYMBOL_SAMPLER_CHANNEL = 94,           /* SAMPLER_CHANNEL  */
  YYSYMBOL_CHANNEL_OUTPUT = 95,            /* CHANNEL_OUTPUT  */
  YYSYMBOL_EXECMODE = 96,                  /* EXECMODE  */
  YYSYMBOL_CNTRL = 97,                     /* CNTRL  */
  YYSYMBOL_FENCE_OPTIONS = 98,             /* FENCE_OPTIONS  */
  YYSYMBOL_ADDR_ADD_OP = 99,               /* ADDR_ADD_OP  */
  YYSYMBOL_UNARY_LOGIC_OP = 100,           /* UNARY_LOGIC_OP  */
  YYSYMBOL_BINARY_LOGIC_OP = 101,          /* BINARY_LOGIC_OP  */
  YYSYMBOL_TERNARY_LOGIC_OP = 102,         /* TERNARY_LOGIC_OP  */
  YYSYMBOL_QUATERNARY_LOGIC_OP = 103,      /* QUATERNARY_LOGIC_OP  */
  YYSYMBOL_SEL_OP = 104,                   /* SEL_OP  */
  YYSYMBOL_MIN_OP = 105,                   /* MIN_OP  */
  YYSYMBOL_MAX_OP = 106,                   /* MAX_OP  */
  YYSYMBOL_ANTI_TRIG_OP = 107,             /* ANTI_TRIG_OP  */
  YYSYMBOL_MATH2_OP = 108,                 /* MATH2_OP  */
  YYSYMBOL_MATH3_OP = 109,                 /* MATH3_OP  */
  YYSYMBOL_ARITH2_OP = 110,                /* ARITH2_OP  */
  YYSYMBOL_ARITH3_OP = 111,                /* ARITH3_OP  */
  YYSYMBOL_ARITH4_OP = 112,                /* ARITH4_OP  */
  YYSYMBOL_ARITH4_OP2 = 113,               /* ARITH4_OP2  */
  YYSYMBOL_CMP_OP = 114,                   /* CMP_OP  */
  YYSYMBOL_SVM_OP = 115,                   /* SVM_OP  */
  YYSYMBOL_SVM_SCATTER_OP = 116,           /* SVM_SCATTER_OP  */
  YYSYMBOL_SVM_GATHER4SCALED_OP = 117,     /* SVM_GATHER4SCALED_OP  */
  YYSYMBOL_SVM_SCATTER4SCALED_OP = 118,    /* SVM_SCATTER4SCALED_OP  */
  YYSYMBOL_SVM_ATOMIC_OP = 119,            /* SVM_ATOMIC_OP  */
  YYSYMBOL_OWORD_OP = 120,                 /* OWORD_OP  */
  YYSYMBOL_MEDIA_OP = 121,                 /* MEDIA_OP  */
  YYSYMBOL_SCATTER_OP = 122,               /* SCATTER_OP  */
  YYSYMBOL_SCATTER_TYPED_OP = 123,         /* SCATTER_TYPED_OP  */
  YYSYMBOL_SCATTER_SCALED_OP = 124,        /* SCATTER_SCALED_OP  */
  YYSYMBOL_SCATTER4_SCALED_OP = 125,       /* SCATTER4_SCALED_OP  */
  YYSYMBOL_BARRIER_OP = 126,               /* BARRIER_OP  */
  YYSYMBOL_SBARRIER_SIGNAL = 127,          /* SBARRIER_SIGNAL  */
  YYSYMBOL_SBARRIER_WAIT = 128,            /* SBARRIER_WAIT  */
  YYSYMBOL_DWORD_ATOMIC_OP = 129,          /* DWORD_ATOMIC_OP  */
  YYSYMBOL_TYPED_ATOMIC_OP = 130,          /* TYPED_ATOMIC_OP  */
  YYSYMBOL_SAMPLE_OP = 131,                /* SAMPLE_OP  */
  YYSYMBOL_SAMPLE_UNORM_OP = 132,          /* SAMPLE_UNORM_OP  */
  YYSYMBOL_VME_IME_OP = 133,               /* VME_IME_OP  */
  YYSYMBOL_VME_SIC_OP = 134,               /* VME_SIC_OP  */
  YYSYMBOL_VME_FBR_OP = 135,               /* VME_FBR_OP  */
  YYSYMBOL_BRANCH_OP = 136,                /* BRANCH_OP  */
  YYSYMBOL_RET_OP = 137,                   /* RET_OP  */
  YYSYMBOL_IFCALL = 138,                   /* IFCALL  */
  YYSYMBOL_FCALL = 139,                    /* FCALL  */
  YYSYMBOL_FADDR = 140,                    /* FADDR  */
  YYSYMBOL_SWITCHJMP_OP = 141,             /* SWITCHJMP_OP  */
  YYSYMBOL_MOVS_OP = 142,                  /* MOVS_OP  */
  YYSYMBOL_SETP_OP = 143,                  /* SETP_OP  */
  YYSYMBOL_MOV_OP = 144,                   /* MOV_OP  */
  YYSYMBOL_FILE_OP = 145,                  /* FILE_OP  */
  YYSYMBOL_LOC_OP = 146,                   /* LOC_OP  */
  YYSYMBOL_CACHE_FLUSH_OP = 147,           /* CACHE_FLUSH_OP  */
  YYSYMBOL_WAIT_OP = 148,                  /* WAIT_OP  */
  YYSYMBOL_FENCE_GLOBAL_OP = 149,          /* FENCE_GLOBAL_OP  */
  YYSYMBOL_FENCE_LOCAL_OP = 150,           /* FENCE_LOCAL_OP  */
  YYSYMBOL_FENCE_SW_OP = 151,              /* FENCE_SW_OP  */
  YYSYMBOL_YIELD_OP = 152,                 /* YIELD_OP  */
  YYSYMBOL_SAMPLE_3D_OP = 153,             /* SAMPLE_3D_OP  */
  YYSYMBOL_LOAD_3D_OP = 154,               /* LOAD_3D_OP  */
  YYSYMBOL_SAMPLE4_3D_OP = 155,            /* SAMPLE4_3D_OP  */
  YYSYMBOL_RESINFO_OP_3D = 156,            /* RESINFO_OP_3D  */
  YYSYMBOL_SAMPLEINFO_OP_3D = 157,         /* SAMPLEINFO_OP_3D  */
  YYSYMBOL_RTWRITE_OP_3D = 158,            /* RTWRITE_OP_3D  */
  YYSYMBOL_URBWRITE_OP_3D = 159,           /* URBWRITE_OP_3D  */
  YYSYMBOL_LIFETIME_START_OP = 160,        /* LIFETIME_START_OP  */
  YYSYMBOL_LIFETIME_END_OP = 161,          /* LIFETIME_END_OP  */
  YYSYMBOL_AVS_OP = 162,                   /* AVS_OP  */
  YYSYMBOL_CALL_OP = 163,                  /* CALL_OP  */
  YYSYMBOL_PRED_CNTL = 164,                /* PRED_CNTL  */
  YYSYMBOL_F32_LIT = 165,                  /* F32_LIT  */
  YYSYMBOL_F64_LIT = 166,                  /* F64_LIT  */
  YYSYMBOL_DEC_LIT = 167,                  /* DEC_LIT  */
  YYSYMBOL_HEX_LIT = 168,                  /* HEX_LIT  */
  YYSYMBOL_BUILTIN_SIZEOF = 169,           /* BUILTIN_SIZEOF  */
  YYSYMBOL_BUILTIN_DISPATCH_SIMD_SIZE = 170, /* BUILTIN_DISPATCH_SIMD_SIZE  */
  YYSYMBOL_QW_SCATTER_OP = 171,            /* QW_SCATTER_OP  */
  YYSYMBOL_LSC_CACHING_OPT = 172,          /* LSC_CACHING_OPT  */
  YYSYMBOL_LSC_ADDR_SIZE_TK = 173,         /* LSC_ADDR_SIZE_TK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK = 174,        /* LSC_DATA_SHAPE_TK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_CHMASK = 175, /* LSC_DATA_SHAPE_TK_CHMASK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_BLOCK2D = 176, /* LSC_DATA_SHAPE_TK_BLOCK2D  */
  YYSYMBOL_LSC_AM_FLAT = 177,              /* LSC_AM_FLAT  */
  YYSYMBOL_LSC_AM_BTI = 178,               /* LSC_AM_BTI  */
  YYSYMBOL_LSC_AM_BSS = 179,               /* LSC_AM_BSS  */
  YYSYMBOL_LSC_AM_SS = 180,                /* LSC_AM_SS  */
  YYSYMBOL_LSC_AM_ARG = 181,               /* LSC_AM_ARG  */
  YYSYMBOL_LSC_FENCE_OP_TYPE = 182,        /* LSC_FENCE_OP_TYPE  */
  YYSYMBOL_LSC_FENCE_SCOPE = 183,          /* LSC_FENCE_SCOPE  */
  YYSYMBOL_LSC_SFID_UNTYPED_TOKEN = 184,   /* LSC_SFID_UNTYPED_TOKEN  */
  YYSYMBOL_LSC_SFID_TYPED_TOKEN = 185,     /* LSC_SFID_TYPED_TOKEN  */
  YYSYMBOL_LSC_LOAD_MNEMONIC = 186,        /* LSC_LOAD_MNEMONIC  */
  YYSYMBOL_LSC_LOAD_STRIDED_MNEMONIC = 187, /* LSC_LOAD_STRIDED_MNEMONIC  */
  YYSYMBOL_LSC_LOAD_BLOCK2D_MNEMONIC = 188, /* LSC_LOAD_BLOCK2D_MNEMONIC  */
  YYSYMBOL_LSC_STORE_MNEMONIC = 189,       /* LSC_STORE_MNEMONIC  */
  YYSYMBOL_LSC_STORE_STRIDED_MNEMONIC = 190, /* LSC_STORE_STRIDED_MNEMONIC  */
  YYSYMBOL_LSC_STORE_BLOCK2D_MNEMONIC = 191, /* LSC_STORE_BLOCK2D_MNEMONIC  */
  YYSYMBOL_LSC_ATOMIC_MNEMONIC = 192,      /* LSC_ATOMIC_MNEMONIC  */
  YYSYMBOL_LSC_READ_STATE_INFO_MNEMONIC = 193, /* LSC_READ_STATE_INFO_MNEMONIC  */
  YYSYMBOL_LSC_FENCE_MNEMONIC = 194,       /* LSC_FENCE_MNEMONIC  */
  YYSYMBOL_FCVT_OP = 195,                  /* FCVT_OP  */
  YYSYMBOL_YYACCEPT = 196,                 /* $accept  */
  YYSYMBOL_Listing = 197,                  /* Listing  */
  YYSYMBOL_ListingHeader = 198,            /* ListingHeader  */
  YYSYMBOL_Statements = 199,               /* Statements  */
  YYSYMBOL_Newlines = 200,                 /* Newlines  */
  YYSYMBOL_NewlinesOpt = 201,              /* NewlinesOpt  */
  YYSYMBOL_Statement = 202,                /* Statement  */
  YYSYMBOL_Scope = 203,                    /* Scope  */
  YYSYMBOL_ScopeStart = 204,               /* ScopeStart  */
  YYSYMBOL_ScopeEnd = 205,                 /* ScopeEnd  */
  YYSYMBOL_IdentOrStringLit = 206,         /* IdentOrStringLit  */
  YYSYMBOL_DirectiveKernel = 207,          /* DirectiveKernel  */
  YYSYMBOL_DirectiveGlobalFunction = 208,  /* DirectiveGlobalFunction  */
  YYSYMBOL_DirectiveVersion = 209,         /* DirectiveVersion  */
  YYSYMBOL_DirectiveDecl = 210,            /* DirectiveDecl  */
  YYSYMBOL_DeclFunction = 211,             /* DeclFunction  */
  YYSYMBOL_DeclVariable = 212,             /* DeclVariable  */
  YYSYMBOL_DeclAddress = 213,              /* DeclAddress  */
  YYSYMBOL_DeclPredicate = 214,            /* DeclPredicate  */
  YYSYMBOL_DeclSampler = 215,              /* DeclSampler  */
  YYSYMBOL_VNameEqOpt = 216,               /* VNameEqOpt  */
  YYSYMBOL_DeclSurface = 217,              /* DeclSurface  */
  YYSYMBOL_DirectiveInput = 218,           /* DirectiveInput  */
  YYSYMBOL_DirectiveImplicitInput = 219,   /* DirectiveImplicitInput  */
  YYSYMBOL_InputOffset = 220,              /* InputOffset  */
  YYSYMBOL_InputSize = 221,                /* InputSize  */
  YYSYMBOL_DirectiveParameter = 222,       /* DirectiveParameter  */
  YYSYMBOL_DirectiveAttr = 223,            /* DirectiveAttr  */
  YYSYMBOL_DirectiveFunc = 224,            /* DirectiveFunc  */
  YYSYMBOL_AlignAttrOpt = 225,             /* AlignAttrOpt  */
  YYSYMBOL_Align = 226,                    /* Align  */
  YYSYMBOL_AliasAttrOpt = 227,             /* AliasAttrOpt  */
  YYSYMBOL_OneAttr = 228,                  /* OneAttr  */
  YYSYMBOL_AttrOpt = 229,                  /* AttrOpt  */
  YYSYMBOL_GenAttrOpt = 230,               /* GenAttrOpt  */
  YYSYMBOL_Instruction = 231,              /* Instruction  */
  YYSYMBOL_Label = 232,                    /* Label  */
  YYSYMBOL_LogicInstruction = 233,         /* LogicInstruction  */
  YYSYMBOL_UnaryLogicInstruction = 234,    /* UnaryLogicInstruction  */
  YYSYMBOL_MathInstruction_2OPND = 235,    /* MathInstruction_2OPND  */
  YYSYMBOL_MathInstruction_3OPND = 236,    /* MathInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_2OPND = 237,   /* ArithInstruction_2OPND  */
  YYSYMBOL_ArithInstruction_3OPND = 238,   /* ArithInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_4OPND = 239,   /* ArithInstruction_4OPND  */
  YYSYMBOL_DpasInstruction = 240,          /* DpasInstruction  */
  YYSYMBOL_BfnInstruction = 241,           /* BfnInstruction  */
  YYSYMBOL_QwScatterInstruction = 242,     /* QwScatterInstruction  */
  YYSYMBOL_BF_CvtInstruction = 243,        /* BF_CvtInstruction  */
  YYSYMBOL_FCvtInstruction = 244,          /* FCvtInstruction  */
  YYSYMBOL_AntiTrigInstruction = 245,      /* AntiTrigInstruction  */
  YYSYMBOL_AddrAddInstruction = 246,       /* AddrAddInstruction  */
  YYSYMBOL_SetpInstruction = 247,          /* SetpInstruction  */
  YYSYMBOL_SelInstruction = 248,           /* SelInstruction  */
  YYSYMBOL_MinInstruction = 249,           /* MinInstruction  */
  YYSYMBOL_MaxInstruction = 250,           /* MaxInstruction  */
  YYSYMBOL_MovInstruction = 251,           /* MovInstruction  */
  YYSYMBOL_MovsInstruction = 252,          /* MovsInstruction  */
  YYSYMBOL_CmpInstruction = 253,           /* CmpInstruction  */
  YYSYMBOL_MediaInstruction = 254,         /* MediaInstruction  */
  YYSYMBOL_MediaInstructionPlaneID = 255,  /* MediaInstructionPlaneID  */
  YYSYMBOL_ScatterInstruction = 256,       /* ScatterInstruction  */
  YYSYMBOL_ScatterTypedInstruction = 257,  /* ScatterTypedInstruction  */
  YYSYMBOL_Scatter4ScaledInstruction = 258, /* Scatter4ScaledInstruction  */
  YYSYMBOL_ScatterScaledInstruction = 259, /* ScatterScaledInstruction  */
  YYSYMBOL_SynchronizationInstruction = 260, /* SynchronizationInstruction  */
  YYSYMBOL_DwordAtomicInstruction = 261,   /* DwordAtomicInstruction  */
  YYSYMBOL_TypedAtomicInstruction = 262,   /* TypedAtomicInstruction  */
  YYSYMBOL_Atomic16Opt = 263,              /* Atomic16Opt  */
  YYSYMBOL_SampleUnormInstruction = 264,   /* SampleUnormInstruction  */
  YYSYMBOL_SampleInstruction = 265,        /* SampleInstruction  */
  YYSYMBOL_Sample3dInstruction = 266,      /* Sample3dInstruction  */
  YYSYMBOL_CPSEnableOpt = 267,             /* CPSEnableOpt  */
  YYSYMBOL_NonUniformSamplerEnableOpt = 268, /* NonUniformSamplerEnableOpt  */
  YYSYMBOL_Load3dInstruction = 269,        /* Load3dInstruction  */
  YYSYMBOL_Gather43dInstruction = 270,     /* Gather43dInstruction  */
  YYSYMBOL_PixelNullMaskEnableOpt = 271,   /* PixelNullMaskEnableOpt  */
  YYSYMBOL_ResInfo3dInstruction = 272,     /* ResInfo3dInstruction  */
  YYSYMBOL_SampleInfo3dInstruction = 273,  /* SampleInfo3dInstruction  */
  YYSYMBOL_RTWriteOperandParse = 274,      /* RTWriteOperandParse  */
  YYSYMBOL_RTWriteInstruction = 275,       /* RTWriteInstruction  */
  YYSYMBOL_RTWriteModeOpt = 276,           /* RTWriteModeOpt  */
  YYSYMBOL_URBWriteInstruction = 277,      /* URBWriteInstruction  */
  YYSYMBOL_AVSInstruction = 278,           /* AVSInstruction  */
  YYSYMBOL_VMEInstruction = 279,           /* VMEInstruction  */
  YYSYMBOL_OwordInstruction = 280,         /* OwordInstruction  */
  YYSYMBOL_SvmInstruction = 281,           /* SvmInstruction  */
  YYSYMBOL_AtomicBitwidthOpt = 282,        /* AtomicBitwidthOpt  */
  YYSYMBOL_LscInstruction = 283,           /* LscInstruction  */
  YYSYMBOL_LscUntypedLoad = 284,           /* LscUntypedLoad  */
  YYSYMBOL_LscUntypedStridedLoad = 285,    /* LscUntypedStridedLoad  */
  YYSYMBOL_LscUntypedBlock2dLoad = 286,    /* LscUntypedBlock2dLoad  */
  YYSYMBOL_LscUntypedStore = 287,          /* LscUntypedStore  */
  YYSYMBOL_LscUntypedStridedStore = 288,   /* LscUntypedStridedStore  */
  YYSYMBOL_LscUntypedBlock2dStore = 289,   /* LscUntypedBlock2dStore  */
  YYSYMBOL_LscUntypedAtomic = 290,         /* LscUntypedAtomic  */
  YYSYMBOL_LscTypedLoad = 291,             /* LscTypedLoad  */
  YYSYMBOL_LscTypedStore = 292,            /* LscTypedStore  */
  YYSYMBOL_LscTypedAtomic = 293,           /* LscTypedAtomic  */
  YYSYMBOL_LscTypedReadStateInfo = 294,    /* LscTypedReadStateInfo  */
  YYSYMBOL_LscFence = 295,                 /* LscFence  */
  YYSYMBOL_LscSfid = 296,                  /* LscSfid  */
  YYSYMBOL_LscCacheOpts = 297,             /* LscCacheOpts  */
  YYSYMBOL_LscUntypedAddrOperand = 298,    /* LscUntypedAddrOperand  */
  YYSYMBOL_LscUntypedStridedAddrOperand = 299, /* LscUntypedStridedAddrOperand  */
  YYSYMBOL_LscUntypedBlock2dAddrOperand = 300, /* LscUntypedBlock2dAddrOperand  */
  YYSYMBOL_LscTypedAddrOperand = 301,      /* LscTypedAddrOperand  */
  YYSYMBOL_LscAddrImmOffsetOpt = 302,      /* LscAddrImmOffsetOpt  */
  YYSYMBOL_LscAddrImmScaleOpt = 303,       /* LscAddrImmScaleOpt  */
  YYSYMBOL_LscAddrModelOpt = 304,          /* LscAddrModelOpt  */
  YYSYMBOL_LscRegAddrModel = 305,          /* LscRegAddrModel  */
  YYSYMBOL_LscRegAddrModelKind = 306,      /* LscRegAddrModelKind  */
  YYSYMBOL_LscVectorOpRegOrImm = 307,      /* LscVectorOpRegOrImm  */
  YYSYMBOL_LscVectorOpImm = 308,           /* LscVectorOpImm  */
  YYSYMBOL_LscVectorOpReg = 309,           /* LscVectorOpReg  */
  YYSYMBOL_LscDataOperand = 310,           /* LscDataOperand  */
  YYSYMBOL_LscDataOperand2D = 311,         /* LscDataOperand2D  */
  YYSYMBOL_LscPayloadReg = 312,            /* LscPayloadReg  */
  YYSYMBOL_LscPayloadNonNullReg = 313,     /* LscPayloadNonNullReg  */
  YYSYMBOL_SwitchLabels = 314,             /* SwitchLabels  */
  YYSYMBOL_BranchInstruction = 315,        /* BranchInstruction  */
  YYSYMBOL_FILE = 316,                     /* FILE  */
  YYSYMBOL_LOC = 317,                      /* LOC  */
  YYSYMBOL_RawSendInstruction = 318,       /* RawSendInstruction  */
  YYSYMBOL_LifetimeStartInst = 319,        /* LifetimeStartInst  */
  YYSYMBOL_LifetimeEndInst = 320,          /* LifetimeEndInst  */
  YYSYMBOL_RawSendsInstruction = 321,      /* RawSendsInstruction  */
  YYSYMBOL_NullaryInstruction = 322,       /* NullaryInstruction  */
  YYSYMBOL_OwordModifier = 323,            /* OwordModifier  */
  YYSYMBOL_Predicate = 324,                /* Predicate  */
  YYSYMBOL_PredSign = 325,                 /* PredSign  */
  YYSYMBOL_PredCtrlOpt = 326,              /* PredCtrlOpt  */
  YYSYMBOL_SatModOpt = 327,                /* SatModOpt  */
  YYSYMBOL_SrcModifier = 328,              /* SrcModifier  */
  YYSYMBOL_ConditionalModifier = 329,      /* ConditionalModifier  */
  YYSYMBOL_VecDstOperand_A = 330,          /* VecDstOperand_A  */
  YYSYMBOL_VecDstOperand_G = 331,          /* VecDstOperand_G  */
  YYSYMBOL_VecDstOperand_G_I = 332,        /* VecDstOperand_G_I  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A_AO = 333, /* VecSrcOperand_G_I_IMM_A_AO  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A = 334,  /* VecSrcOperand_G_I_IMM_A  */
  YYSYMBOL_VecSrcOperand_G_I_IMM = 335,    /* VecSrcOperand_G_I_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM = 336,      /* VecSrcOperand_G_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM_AO = 337,   /* VecSrcOperand_G_IMM_AO  */
  YYSYMBOL_VecSrcOperand_G_A = 338,        /* VecSrcOperand_G_A  */
  YYSYMBOL_VecSrcOperand_G_A_AO = 339,     /* VecSrcOperand_G_A_AO  */
  YYSYMBOL_VecSrcOperand_G = 340,          /* VecSrcOperand_G  */
  YYSYMBOL_VecSrcOpndSimple = 341,         /* VecSrcOpndSimple  */
  YYSYMBOL_VMEOpndIME = 342,               /* VMEOpndIME  */
  YYSYMBOL_VMEOpndFBR = 343,               /* VMEOpndFBR  */
  YYSYMBOL_SrcStateOperand = 344,          /* SrcStateOperand  */
  YYSYMBOL_DstStateOperand = 345,          /* DstStateOperand  */
  YYSYMBOL_RawOperand = 346,               /* RawOperand  */
  YYSYMBOL_RawOperandNonNull = 347,        /* RawOperandNonNull  */
  YYSYMBOL_RawOperandOffsetSuffix = 348,   /* RawOperandOffsetSuffix  */
  YYSYMBOL_RawOperandArray = 349,          /* RawOperandArray  */
  YYSYMBOL_DstAddrOperand = 350,           /* DstAddrOperand  */
  YYSYMBOL_DstGeneralOperand = 351,        /* DstGeneralOperand  */
  YYSYMBOL_DstIndirectOperand = 352,       /* DstIndirectOperand  */
  YYSYMBOL_SrcAddrOfOperand = 353,         /* SrcAddrOfOperand  */
  YYSYMBOL_AddrOfVar = 354,                /* AddrOfVar  */
  YYSYMBOL_SrcAddrOperand = 355,           /* SrcAddrOperand  */
  YYSYMBOL_SrcGeneralOperand = 356,        /* SrcGeneralOperand  */
  YYSYMBOL_SrcImmOperand = 357,            /* SrcImmOperand  */
  YYSYMBOL_FloatLit = 358,                 /* FloatLit  */
  YYSYMBOL_DoubleFloatLit = 359,           /* DoubleFloatLit  */
  YYSYMBOL_SrcIndirectOperand = 360,       /* SrcIndirectOperand  */
  YYSYMBOL_DstRegion = 361,                /* DstRegion  */
  YYSYMBOL_SrcRegionDirect = 362,          /* SrcRegionDirect  */
  YYSYMBOL_SrcRegionIndirect = 363,        /* SrcRegionIndirect  */
  YYSYMBOL_IndirectVarAccess = 364,        /* IndirectVarAccess  */
  YYSYMBOL_TwoDimOffset = 365,             /* TwoDimOffset  */
  YYSYMBOL_PredVar = 366,                  /* PredVar  */
  YYSYMBOL_AddrVarAccess = 367,            /* AddrVarAccess  */
  YYSYMBOL_AddrVarAccessWithWidth = 368,   /* AddrVarAccessWithWidth  */
  YYSYMBOL_SIMDMode = 369,                 /* SIMDMode  */
  YYSYMBOL_ElemNum = 370,                  /* ElemNum  */
  YYSYMBOL_ExecSize = 371,                 /* ExecSize  */
  YYSYMBOL_ExecSizeInt = 372,              /* ExecSizeInt  */
  YYSYMBOL_Var = 373,                      /* Var  */
  YYSYMBOL_VarNonNull = 374,               /* VarNonNull  */
  YYSYMBOL_IntExp = 375,                   /* IntExp  */
  YYSYMBOL_IntExpCond = 376,               /* IntExpCond  */
  YYSYMBOL_IntExpAND = 377,                /* IntExpAND  */
  YYSYMBOL_IntExpXOR = 378,                /* IntExpXOR  */
  YYSYMBOL_IntExpOR = 379,                 /* IntExpOR  */
  YYSYMBOL_IntExpCmp = 380,                /* IntExpCmp  */
  YYSYMBOL_IntExpRel = 381,                /* IntExpRel  */
  YYSYMBOL_IntExpNRA = 382,                /* IntExpNRA  */
  YYSYMBOL_IntExpShift = 383,              /* IntExpShift  */
  YYSYMBOL_IntExpAdd = 384,                /* IntExpAdd  */
  YYSYMBOL_IntExpMul = 385,                /* IntExpMul  */
  YYSYMBOL_IntExpUnr = 386,                /* IntExpUnr  */
  YYSYMBOL_IntExpPrim = 387,               /* IntExpPrim  */
  YYSYMBOL_DataType = 388,                 /* DataType  */
  YYSYMBOL_DataTypeIntOrVector = 389       /* DataTypeIntOrVector  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3053

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  196
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  194
/* YYNRULES -- Number of rules.  */
#define YYNRULES  435
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1098

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   450


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   624,   624,   629,   631,   631,   633,   633,   634,   634,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   652,   653,   654,   658,   662,   665,   665,   672,   680,
     688,   695,   696,   697,   698,   699,   700,   702,   709,   717,
     725,   732,   736,   736,   739,   747,   752,   764,   771,   779,
     779,   780,   787,   793,   797,   801,   805,   810,   816,   816,
     818,   822,   828,   836,   842,   847,   852,   858,   862,   866,
     872,   877,   883,   887,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   950,   954,   960,   965,   971,
     979,   985,   992,   999,  1006,  1013,  1025,  1032,  1041,  1051,
    1057,  1064,  1070,  1076,  1085,  1095,  1102,  1109,  1117,  1126,
    1133,  1140,  1146,  1152,  1158,  1176,  1183,  1193,  1201,  1208,
    1215,  1224,  1233,  1242,  1250,  1253,  1256,  1259,  1262,  1267,
    1274,  1282,  1283,  1289,  1298,  1306,  1314,  1326,  1326,  1328,
    1328,  1331,  1344,  1356,  1356,  1359,  1367,  1375,  1378,  1382,
    1387,  1397,  1397,  1401,  1409,  1421,  1437,  1443,  1456,  1464,
    1471,  1477,  1483,  1489,  1496,  1497,  1506,  1507,  1508,  1510,
    1511,  1512,  1514,  1517,  1518,  1519,  1520,  1522,  1544,  1575,
    1604,  1629,  1653,  1680,  1706,  1740,  1780,  1820,  1851,  1886,
    1891,  1891,  1894,  1895,  1896,  1900,  1909,  1915,  1923,  1946,
    1957,  1968,  1979,  1992,  1993,  1994,  2001,  2002,  2005,  2006,
    2007,  2008,  2012,  2017,  2018,  2019,  2021,  2021,  2024,  2029,
    2037,  2045,  2059,  2063,  2069,  2074,  2077,  2081,  2084,  2089,
    2092,  2095,  2102,  2106,  2110,  2114,  2120,  2125,  2132,  2137,
    2142,  2148,  2155,  2162,  2168,  2174,  2182,  2190,  2198,  2207,
    2212,  2217,  2222,  2227,  2232,  2237,  2242,  2247,  2247,  2253,
    2258,  2263,  2263,  2265,  2265,  2268,  2268,  2271,  2272,  2273,
    2274,  2276,  2276,  2281,  2282,  2284,  2285,  2289,  2290,  2293,
    2294,  2297,  2298,  2299,  2302,  2303,  2306,  2307,  2308,  2311,
    2312,  2315,  2316,  2318,  2320,  2330,  2337,  2345,  2353,  2372,
    2384,  2391,  2403,  2408,  2415,  2420,  2428,  2436,  2442,  2447,
    2469,  2473,  2479,  2489,  2497,  2504,  2514,  2520,  2527,  2531,
    2536,  2540,  2546,  2547,  2554,  2562,  2563,  2569,  2579,  2587,
    2596,  2614,  2628,  2631,  2642,  2653,  2658,  2663,  2671,  2680,
    2692,  2706,  2708,  2719,  2731,  2737,  2745,  2754,  2754,  2755,
    2755,  2758,  2760,  2761,  2763,  2764,  2766,  2767,  2769,  2770,
    2772,  2773,  2774,  2776,  2777,  2778,  2779,  2780,  2797,  2800,
    2801,  2802,  2803,  2805,  2806,  2807,  2809,  2810,  2815,  2820,
    2822,  2823,  2824,  2825,  2829,  2830,  2832,  2836,  2840,  2846,
    2855,  2856,  2857,  2858,  2860,  2861
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ALIGN_KEYWORD",
  "ATOMIC_SUB_OP", "DIRECTIVE_DECL", "DIRECTIVE_FUNC",
  "DIRECTIVE_FUNCDECL", "DIRECTIVE_GLOBAL_FUNC", "DIRECTIVE_IMPLICIT",
  "DIRECTIVE_INPUT", "DIRECTIVE_KERNEL", "DIRECTIVE_KERNEL_ATTR",
  "DIRECTIVE_PARAMETER", "DIRECTIVE_VERSION", "ALIAS_EQ", "ALIGN_EQ",
  "ATTR_EQ", "OFFSET_EQ", "NUM_ELTS_EQ", "V_NAME_EQ", "SIZE_EQ",
  "V_TYPE_EQ_G", "V_TYPE_EQ_P", "V_TYPE_EQ_A", "V_TYPE_EQ_S",
  "V_TYPE_EQ_T", "CPS", "NON_UNIFORM_SAMPLER", "PIXEL_NULL_MASK",
  "RAW_SENDC_STRING", "RAW_SENDSC_EOT_STRING", "RAW_SENDSC_STRING",
  "RAW_SENDS_EOT_STRING", "RAW_SENDS_STRING", "RAW_SEND_STRING", "SAT",
  "SRCMOD_ABS", "SRCMOD_NEG", "SRCMOD_NEGABS", "SRCMOD_NOT", "BFN_OP",
  "DPAS_OP", "BF_CVT_OP", "NBARRIER_SIGNAL", "NBARRIER_WAIT", "ITYPE",
  "DECL_DATA_TYPE", "DFTYPE", "FTYPE", "HFTYPE", "VTYPE", "COND_MOD",
  "LANGLE", "RANGLE", "LBRACK", "RBRACK", "IND_LBRACK", "LPAREN", "RPAREN",
  "LBRACE", "RBRACE", "DOT", "COMMA", "SEMI", "COLON", "SLASH", "PERCENT",
  "EQUALS", "PLUS", "MINUS", "TIMES", "AMP", "CIRC", "PIPE", "TILDE",
  "BANG", "QUESTION", "LEQ", "GEQ", "EQ", "NEQ", "SHL", "SHRS", "SHRZ",
  "LABEL", "IDENT", "BUILTIN_NULL", "BUILTIN", "STRING_LIT", "NEWLINE",
  "RTWRITE_OPTION", "MEDIA_MODE", "OWORD_MODIFIER", "SAMPLER_CHANNEL",
  "CHANNEL_OUTPUT", "EXECMODE", "CNTRL", "FENCE_OPTIONS", "ADDR_ADD_OP",
  "UNARY_LOGIC_OP", "BINARY_LOGIC_OP", "TERNARY_LOGIC_OP",
  "QUATERNARY_LOGIC_OP", "SEL_OP", "MIN_OP", "MAX_OP", "ANTI_TRIG_OP",
  "MATH2_OP", "MATH3_OP", "ARITH2_OP", "ARITH3_OP", "ARITH4_OP",
  "ARITH4_OP2", "CMP_OP", "SVM_OP", "SVM_SCATTER_OP",
  "SVM_GATHER4SCALED_OP", "SVM_SCATTER4SCALED_OP", "SVM_ATOMIC_OP",
  "OWORD_OP", "MEDIA_OP", "SCATTER_OP", "SCATTER_TYPED_OP",
  "SCATTER_SCALED_OP", "SCATTER4_SCALED_OP", "BARRIER_OP",
  "SBARRIER_SIGNAL", "SBARRIER_WAIT", "DWORD_ATOMIC_OP", "TYPED_ATOMIC_OP",
  "SAMPLE_OP", "SAMPLE_UNORM_OP", "VME_IME_OP", "VME_SIC_OP", "VME_FBR_OP",
  "BRANCH_OP", "RET_OP", "IFCALL", "FCALL", "FADDR", "SWITCHJMP_OP",
  "MOVS_OP", "SETP_OP", "MOV_OP", "FILE_OP", "LOC_OP", "CACHE_FLUSH_OP",
  "WAIT_OP", "FENCE_GLOBAL_OP", "FENCE_LOCAL_OP", "FENCE_SW_OP",
  "YIELD_OP", "SAMPLE_3D_OP", "LOAD_3D_OP", "SAMPLE4_3D_OP",
  "RESINFO_OP_3D", "SAMPLEINFO_OP_3D", "RTWRITE_OP_3D", "URBWRITE_OP_3D",
  "LIFETIME_START_OP", "LIFETIME_END_OP", "AVS_OP", "CALL_OP", "PRED_CNTL",
  "F32_LIT", "F64_LIT", "DEC_LIT", "HEX_LIT", "BUILTIN_SIZEOF",
  "BUILTIN_DISPATCH_SIMD_SIZE", "QW_SCATTER_OP", "LSC_CACHING_OPT",
  "LSC_ADDR_SIZE_TK", "LSC_DATA_SHAPE_TK", "LSC_DATA_SHAPE_TK_CHMASK",
  "LSC_DATA_SHAPE_TK_BLOCK2D", "LSC_AM_FLAT", "LSC_AM_BTI", "LSC_AM_BSS",
  "LSC_AM_SS", "LSC_AM_ARG", "LSC_FENCE_OP_TYPE", "LSC_FENCE_SCOPE",
  "LSC_SFID_UNTYPED_TOKEN", "LSC_SFID_TYPED_TOKEN", "LSC_LOAD_MNEMONIC",
  "LSC_LOAD_STRIDED_MNEMONIC", "LSC_LOAD_BLOCK2D_MNEMONIC",
  "LSC_STORE_MNEMONIC", "LSC_STORE_STRIDED_MNEMONIC",
  "LSC_STORE_BLOCK2D_MNEMONIC", "LSC_ATOMIC_MNEMONIC",
  "LSC_READ_STATE_INFO_MNEMONIC", "LSC_FENCE_MNEMONIC", "FCVT_OP",
  "$accept", "Listing", "ListingHeader", "Statements", "Newlines",
  "NewlinesOpt", "Statement", "Scope", "ScopeStart", "ScopeEnd",
  "IdentOrStringLit", "DirectiveKernel", "DirectiveGlobalFunction",
  "DirectiveVersion", "DirectiveDecl", "DeclFunction", "DeclVariable",
  "DeclAddress", "DeclPredicate", "DeclSampler", "VNameEqOpt",
  "DeclSurface", "DirectiveInput", "DirectiveImplicitInput", "InputOffset",
  "InputSize", "DirectiveParameter", "DirectiveAttr", "DirectiveFunc",
  "AlignAttrOpt", "Align", "AliasAttrOpt", "OneAttr", "AttrOpt",
  "GenAttrOpt", "Instruction", "Label", "LogicInstruction",
  "UnaryLogicInstruction", "MathInstruction_2OPND",
  "MathInstruction_3OPND", "ArithInstruction_2OPND",
  "ArithInstruction_3OPND", "ArithInstruction_4OPND", "DpasInstruction",
  "BfnInstruction", "QwScatterInstruction", "BF_CvtInstruction",
  "FCvtInstruction", "AntiTrigInstruction", "AddrAddInstruction",
  "SetpInstruction", "SelInstruction", "MinInstruction", "MaxInstruction",
  "MovInstruction", "MovsInstruction", "CmpInstruction",
  "MediaInstruction", "MediaInstructionPlaneID", "ScatterInstruction",
  "ScatterTypedInstruction", "Scatter4ScaledInstruction",
  "ScatterScaledInstruction", "SynchronizationInstruction",
  "DwordAtomicInstruction", "TypedAtomicInstruction", "Atomic16Opt",
  "SampleUnormInstruction", "SampleInstruction", "Sample3dInstruction",
  "CPSEnableOpt", "NonUniformSamplerEnableOpt", "Load3dInstruction",
  "Gather43dInstruction", "PixelNullMaskEnableOpt", "ResInfo3dInstruction",
  "SampleInfo3dInstruction", "RTWriteOperandParse", "RTWriteInstruction",
  "RTWriteModeOpt", "URBWriteInstruction", "AVSInstruction",
  "VMEInstruction", "OwordInstruction", "SvmInstruction",
  "AtomicBitwidthOpt", "LscInstruction", "LscUntypedLoad",
  "LscUntypedStridedLoad", "LscUntypedBlock2dLoad", "LscUntypedStore",
  "LscUntypedStridedStore", "LscUntypedBlock2dStore", "LscUntypedAtomic",
  "LscTypedLoad", "LscTypedStore", "LscTypedAtomic",
  "LscTypedReadStateInfo", "LscFence", "LscSfid", "LscCacheOpts",
  "LscUntypedAddrOperand", "LscUntypedStridedAddrOperand",
  "LscUntypedBlock2dAddrOperand", "LscTypedAddrOperand",
  "LscAddrImmOffsetOpt", "LscAddrImmScaleOpt", "LscAddrModelOpt",
  "LscRegAddrModel", "LscRegAddrModelKind", "LscVectorOpRegOrImm",
  "LscVectorOpImm", "LscVectorOpReg", "LscDataOperand", "LscDataOperand2D",
  "LscPayloadReg", "LscPayloadNonNullReg", "SwitchLabels",
  "BranchInstruction", "FILE", "LOC", "RawSendInstruction",
  "LifetimeStartInst", "LifetimeEndInst", "RawSendsInstruction",
  "NullaryInstruction", "OwordModifier", "Predicate", "PredSign",
  "PredCtrlOpt", "SatModOpt", "SrcModifier", "ConditionalModifier",
  "VecDstOperand_A", "VecDstOperand_G", "VecDstOperand_G_I",
  "VecSrcOperand_G_I_IMM_A_AO", "VecSrcOperand_G_I_IMM_A",
  "VecSrcOperand_G_I_IMM", "VecSrcOperand_G_IMM", "VecSrcOperand_G_IMM_AO",
  "VecSrcOperand_G_A", "VecSrcOperand_G_A_AO", "VecSrcOperand_G",
  "VecSrcOpndSimple", "VMEOpndIME", "VMEOpndFBR", "SrcStateOperand",
  "DstStateOperand", "RawOperand", "RawOperandNonNull",
  "RawOperandOffsetSuffix", "RawOperandArray", "DstAddrOperand",
  "DstGeneralOperand", "DstIndirectOperand", "SrcAddrOfOperand",
  "AddrOfVar", "SrcAddrOperand", "SrcGeneralOperand", "SrcImmOperand",
  "FloatLit", "DoubleFloatLit", "SrcIndirectOperand", "DstRegion",
  "SrcRegionDirect", "SrcRegionIndirect", "IndirectVarAccess",
  "TwoDimOffset", "PredVar", "AddrVarAccess", "AddrVarAccessWithWidth",
  "SIMDMode", "ElemNum", "ExecSize", "ExecSizeInt", "Var", "VarNonNull",
  "IntExp", "IntExpCond", "IntExpAND", "IntExpXOR", "IntExpOR",
  "IntExpCmp", "IntExpRel", "IntExpNRA", "IntExpShift", "IntExpAdd",
  "IntExpMul", "IntExpUnr", "IntExpPrim", "DataType",
  "DataTypeIntOrVector", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-987)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-425)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -36,  -987,    42,    -2,   104,  -987,  -987,   -32,   -36,  -987,
     114,  2797,   -12,    77,     1,   108,     1,    80,   120,     1,
     127,   166,   132,   132,  1136,  1136,   181,  -987,  -987,   132,
     220,   132,   195,   208,   243,  -987,  -987,  -987,   214,   241,
     261,   146,   286,   263,   132,   132,   132,   262,   186,  -987,
    1290,   269,   287,  -987,  -987,   265,   300,   310,   321,   314,
    -121,   132,   -36,  -987,  -987,  2630,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  2860,  -987,   292,  -987,  -987,
    -987,  -987,  -987,   391,   391,  -987,   342,   392,   -53,   211,
     146,  -987,  -987,  -987,  -987,   146,   231,   126,   231,   231,
    -987,  -987,  -987,  -987,  -987,   171,    54,    -8,  -987,   -18,
    1136,  -987,  -987,  -987,  -987,  -987,  -987,   361,   354,  -987,
       2,  -987,  -987,  -987,   146,   146,  -987,   132,  1136,  -987,
     132,   354,   248,   132,   360,   322,   252,   146,   211,  1136,
     146,   -18,  1136,   146,   146,  -987,  -987,   146,  -987,  -987,
    -987,  -987,  -987,   132,   132,  -987,  -987,   146,  -987,  -987,
     239,   146,  1476,  -987,  -987,  2070,   132,   243,   243,   243,
     243,   132,   401,   401,   401,   401,   401,   401,   401,   401,
     401,   401,   401,   401,   401,   401,   132,   376,   345,   346,
     437,   348,   381,   350,   443,   444,   132,   132,   132,   132,
     401,   423,   423,   423,   362,   132,   132,   397,   100,   270,
     276,   118,   278,   279,   161,   280,   417,   447,   450,   451,
     456,   231,   165,   392,   201,   231,   459,  -987,   418,   415,
     419,   211,  -987,   421,  1290,  -987,    93,    11,   426,   231,
    -987,  -987,   420,  -987,    76,   412,   413,  -987,   230,    89,
    -987,   185,   207,  -987,   299,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,   400,  -987,   361,   354,  -987,
     231,  -987,   212,   231,   435,  -987,  -987,  -987,   327,  -987,
      20,  -987,  -987,   434,   -18,   211,   146,   146,  -987,   195,
     329,   146,   146,   436,   211,   211,   438,   211,  -987,  -987,
    -987,   452,   439,   146,  1136,   147,  1136,   146,   146,   146,
     317,  1290,  -987,  -987,   -36,  -987,   335,   243,   243,   243,
     243,   336,  -987,   132,   132,   132,   132,   132,   132,   132,
     132,   132,   132,   132,   132,   132,   132,   -18,   339,   132,
     132,   446,   132,   344,   132,   454,   454,     1,  -987,  1136,
     427,   132,  -987,   485,   424,   425,  -987,   132,   347,     1,
     353,   358,   358,   358,   358,   358,   358,   358,   358,   358,
     358,   246,   498,   231,   231,   231,   231,  -987,   462,   459,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,   366,   369,   211,
     -33,  -987,  -987,   231,  -987,   452,  -987,   231,   231,  -987,
     231,   231,   231,   231,   231,   231,   231,   231,   231,   231,
     231,   231,   231,   231,   231,   231,   231,   231,   478,   212,
     435,   293,   150,  -987,  -987,  -987,  -987,  -987,   477,   231,
    -987,  -987,   486,   146,  -987,  1628,  -987,  -987,   491,  -987,
    -987,   489,   231,  1136,  1136,    93,  -987,  1136,  1404,   146,
     490,   246,   146,   383,   211,   211,  1136,   211,   212,   -14,
    -987,   493,  -987,  -987,   494,   231,  -987,   211,   211,  1136,
    -987,  -987,   487,   402,   243,   243,   243,   243,   404,   -18,
     -18,   -18,   -18,   -18,   -18,   -18,   -18,   -18,   -18,   -18,
     -18,   -18,   -18,   -18,   512,  1136,  1136,   409,   132,   146,
     132,   146,   410,   132,   132,  -987,   411,   414,   -18,  -987,
     551,   132,   132,   146,   416,  -987,   132,   408,   132,   132,
     132,   132,   132,   132,   132,   132,   132,   132,   419,   160,
    -987,  -987,   421,   231,   459,   459,   564,   564,   499,  -987,
     527,  -987,   146,   231,  -987,   535,  -987,   534,   532,   412,
      10,   413,  -987,  -987,  -987,  -987,  -987,  -987,  -987,   207,
     207,   294,   294,   294,  -987,  -987,  -987,  -987,  -987,  -987,
     428,   231,   231,   231,   533,  -987,  -987,  -987,  -987,  -987,
    -987,   231,   231,   537,  1136,  1136,   211,   129,  1136,  1136,
    1136,  -987,   211,   211,  1136,   556,   211,  -987,   554,   211,
    -987,   -14,   -14,   559,   231,   231,   153,   211,  -987,  1136,
    -987,   453,   132,   132,   243,   243,   461,  1136,  1136,   146,
    1136,   146,  1136,  1136,  1136,  1136,  1136,  1136,  1136,  1136,
    1136,  1136,  1136,  1136,   465,   211,   211,  -987,   211,   211,
     146,  1136,  -987,   146,   146,   466,   470,   911,   911,   198,
    -987,   525,  1136,  1136,  -987,   211,   146,  -987,   246,   246,
     246,   246,   145,   160,   145,   473,   246,   246,  -987,  -987,
    -987,  -987,   563,   622,  -987,  -987,   553,   459,   459,   583,
    -987,   203,  -987,  -987,   354,   594,  -987,  -987,  -987,   231,
     602,   595,   598,   603,   167,   607,  -987,  -987,  -987,  1136,
     211,   211,   211,   211,  1136,  -987,   211,  1136,  -987,  -987,
    -987,  -987,   606,   216,  -987,  -987,  1136,  1290,  1290,  1290,
     132,   132,  1290,  1136,  -987,  -987,  1136,   146,  1136,  1136,
    1136,  1136,  1136,  -987,  -987,  1136,  -987,  1136,  1136,  1136,
     132,   211,   211,   211,   211,  1136,   211,   211,   211,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,   489,   132,
     146,   146,  1643,   211,   211,   145,   213,   160,   145,   473,
     504,  -987,  -987,   246,   626,  -987,   246,   627,  -987,   246,
     628,   629,   246,   145,   160,    40,    25,   646,  -987,  -987,
    -987,  -987,   304,  -987,   499,  -987,  -987,  -987,  -987,   231,
    -987,  -987,   231,   211,  -987,   211,   211,   211,  1136,   211,
     630,  -987,  1136,   211,  1290,  1290,  1290,  1290,   211,  1136,
    -987,  -987,  1136,  1136,  -987,  -987,  -987,  -987,  -987,  1136,
    -987,   211,  -987,  -987,   211,   211,   211,   211,   211,   211,
    1136,   211,   146,  -987,  -987,   211,   211,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,   231,  -987,   101,  -987,   231,
     146,  -987,   246,   246,   632,  -987,  -987,   225,  -987,  -987,
    -987,  -987,  -987,   609,   459,  -987,  -987,  -987,   634,   638,
    -987,  -987,  -987,   211,  1136,   211,  -987,  1136,   211,   211,
     211,  1290,  1290,   211,  -987,  -987,  1136,  -987,   211,   211,
     211,   211,  -987,   211,   211,   146,  -987,   211,   211,  -987,
     101,   215,    30,  -987,   421,   101,   623,   246,   246,  -987,
     231,   529,    72,  -987,  -987,  -987,  -987,   211,  -987,  1136,
    -987,   211,   211,   211,   211,  -987,  -987,  -987,  -987,   211,
    -987,   211,   211,   146,   211,  -987,  -987,   303,   231,   521,
     101,   303,    40,  -987,  -987,   637,  -987,  -987,   640,  -987,
    1136,   211,   211,   211,   211,  -987,  -987,   211,   211,  -987,
     211,   231,    55,   641,  -987,    67,    68,   642,   231,   231,
     610,  -987,  -987,   211,   211,   211,  -987,   294,  -987,   531,
     536,   101,    40,    40,   647,   654,  1136,  -987,  -987,   211,
     211,  -987,  -987,    73,   656,   650,  -987,  -987,   614,  -987,
     542,   101,   543,    40,  1136,  -987,   663,  -987,   657,   211,
     550,    40,  -987,  -987,   661,    40,   669,  -987
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       8,     7,     0,     9,     0,     1,     6,     0,     8,     3,
       0,   299,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   301,    24,   125,     0,
     311,     0,   297,     0,     0,   164,   165,   166,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   289,
       0,   292,   294,   296,   291,     0,     0,     0,     0,     0,
       0,     0,     8,     5,    20,     0,    11,    12,    10,    36,
      31,    32,    33,    34,    35,    14,    13,    15,    17,    16,
      18,    19,    74,    76,    77,    78,    79,    80,    81,   119,
     120,   121,   122,   124,    82,    83,   104,   101,   102,   103,
     100,    99,    84,    85,    87,    88,    90,    89,    91,    93,
      94,    96,    95,   109,   110,   111,   112,   113,   114,   115,
      98,    97,    86,    75,   123,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,    92,   105,   106,
     107,   116,   117,   108,   118,     0,    30,     0,    26,    27,
      57,    37,    29,    49,    49,    28,    55,     0,     0,     0,
       0,   308,   307,   309,   310,     0,     0,     0,     0,     0,
     389,   388,   390,   362,   365,   424,   425,     0,   429,     0,
       0,   321,   333,   323,   358,   360,   322,     0,     0,   387,
       0,   423,   168,   302,     0,     0,   312,     0,     0,   298,
       0,     0,     0,     0,   381,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   279,   280,     0,   290,   324,
     325,   293,   295,     0,     0,   283,   284,     0,   230,   231,
       0,     0,   299,     2,    23,   299,     0,     0,     0,     0,
       0,     0,   305,   305,   305,   305,   305,   305,   305,   305,
     305,   305,   305,   305,   305,   305,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     305,   183,   183,   183,   191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    72,    46,    56,     0,    72,   386,     0,     0,
       0,     0,   339,     0,     0,   314,     0,     0,     0,     0,
     424,   425,     0,   391,   393,   395,   397,   399,   402,   407,
     408,   412,   415,   419,   425,   359,   361,   420,   421,   422,
     366,   363,   367,   364,   357,     0,   427,     0,     0,   167,
       0,   372,     0,     0,     0,   434,   435,   356,   303,   378,
       0,   313,   346,     0,     0,     0,     0,     0,   383,   297,
       0,     0,     0,     0,     0,     0,     0,     0,   278,   315,
     316,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     4,    25,     8,    21,     0,     0,     0,     0,
       0,     0,   306,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   204,     0,     0,     0,   171,   171,     0,   274,     0,
       0,     0,   184,   177,     0,     0,   192,     0,     0,     0,
       0,   232,   232,   232,   232,   232,   232,   232,   232,   232,
     232,     0,     0,     0,     0,     0,     0,    50,     0,    72,
      48,    45,    53,    54,    51,    52,   384,     0,     0,     0,
       0,   341,   141,     0,   348,     0,   376,     0,     0,   426,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   407,   431,   432,   433,   368,   430,     0,     0,
     354,   304,     0,     0,   331,     0,   329,   332,   350,   330,
     353,     0,     0,     0,     0,   378,   199,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   269,
     153,     0,   154,   152,     0,     0,   145,     0,     0,     0,
     229,   142,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   272,     0,     0,     0,   178,
     179,     0,     0,     0,     0,   273,     0,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   388,     0,
     265,   266,   387,     0,    72,    72,    42,    42,     0,    47,
       0,   340,     0,     0,   342,     0,   347,     0,     0,   394,
       0,   396,   398,   400,   401,   403,   404,   405,   406,   413,
     414,   409,   410,   411,   417,   418,   416,   428,   369,   355,
       0,     0,   374,     0,     0,   300,   352,   144,   326,   328,
     327,     0,     0,     0,     0,     0,     0,   159,     0,     0,
       0,   382,     0,     0,     0,     0,     0,   196,     0,     0,
     349,   269,   269,     0,     0,     0,     0,     0,   186,     0,
      22,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   205,     0,     0,
       0,     0,   172,     0,     0,     0,     0,     0,     0,     0,
     180,     0,     0,     0,   187,     0,     0,   234,     0,     0,
       0,     0,   248,     0,   248,     0,     0,     0,   255,   253,
     254,   228,     0,    58,    40,    39,     0,    72,    72,    69,
      71,     0,   385,   138,     0,     0,   370,   375,   379,     0,
       0,     0,     0,     0,     0,     0,   156,   155,   198,     0,
       0,     0,     0,     0,     0,   335,     0,     0,   197,   270,
     271,   275,     0,     0,   338,   185,     0,     0,     0,     0,
       0,     0,     0,     0,   130,   131,     0,     0,     0,     0,
       0,     0,     0,   143,   132,     0,   134,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   277,
     276,   150,   317,   319,   318,   320,   149,   151,   378,     0,
       0,     0,   190,     0,     0,   248,     0,     0,   248,     0,
       0,   249,   250,     0,     0,   251,     0,     0,   237,     0,
       0,     0,     0,   248,     0,     0,     0,    64,    59,    43,
      41,    44,     0,    73,     0,   334,   343,   392,   373,     0,
     377,   351,     0,     0,   158,     0,     0,     0,     0,     0,
       0,   337,     0,     0,     0,     0,     0,     0,     0,     0,
     126,   127,     0,     0,   146,   147,   148,   133,   135,     0,
     137,     0,   202,   203,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   188,   189,     0,     0,   218,   262,   263,
     225,   219,   220,   264,   221,   246,   226,     0,   222,   246,
       0,   223,     0,     0,     0,   257,   256,   259,   258,    63,
      60,    61,    62,     0,    72,    68,    67,    70,     0,     0,
     157,   160,   175,     0,     0,     0,   336,     0,     0,     0,
       0,     0,     0,     0,   139,   128,     0,   136,     0,     0,
       0,     0,   162,     0,     0,     0,   344,     0,     0,   140,
       0,     0,     0,   267,   268,     0,     0,     0,     0,   252,
       0,     0,     0,    38,   371,   380,   174,     0,   195,     0,
     282,     0,     0,     0,     0,   281,   129,   200,   201,     0,
     163,     0,     0,     0,   181,   344,   193,   243,   247,     0,
       0,   243,     0,   224,   227,     0,   260,    66,     0,   173,
       0,     0,     0,     0,     0,   161,   169,     0,     0,   345,
     182,     0,     0,     0,   239,     0,     0,     0,     0,     0,
       0,   288,   287,     0,     0,     0,   344,   244,   245,     0,
       0,     0,     0,     0,     0,     0,     0,   286,   285,     0,
     176,   235,   240,     0,     0,     0,   261,    65,     0,   170,
       0,     0,     0,     0,     0,   241,     0,   236,     0,     0,
       0,     0,   194,   242,     0,     0,     0,   238
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -987,  -987,  -987,   492,   -48,     0,   496,  -987,  -987,   184,
     -13,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
     122,  -987,  -987,  -987,   577,    83,  -987,  -987,  -987,  -987,
    -987,  -987,  -128,  -987,  -292,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,   326,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,   119,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,   209,  -716,  -101,   -96,  -758,  -283,  -185,  -705,  -584,
    -987,  -986,  -987,  -183,  -699,  -106,  -394,  -929,  -269,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,   393,  -987,  -987,
    -987,   359,     5,  -987,   176,  -170,  -313,    37,  -987,   -24,
    -260,  -987,  -987,  -987,    39,  -987,  -987,  -987,   382,  -987,
     876,  -900,  -987,  -975,  -987,  -114,  -987,  -326,  -987,   407,
    -987,    16,   592,   593,  -987,  -353,  -325,   429,  -127,  -184,
    -209,  -987,  -188,  -987,  -217,  1896,   306,     4,   384,   155,
       6,   290,   297,   298,   291,   -69,  -338,  -987,  -473,  -468,
    1508,  -271,  -457,   589
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,     8,    62,     3,     4,    63,    64,    65,   385,
     150,    66,    67,     9,    68,    69,    70,    71,    72,    73,
     747,    74,    75,    76,   292,   296,    77,    78,    79,   857,
     858,   944,   750,   751,   450,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   658,
     104,   105,   106,   107,   108,   109,   110,   573,   111,   112,
     113,   580,   721,   114,   115,   423,   116,   117,   832,   118,
     427,   119,   120,   121,   122,   123,   568,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     230,   588,   848,   849,   852,   846,  1043,   980,   844,   845,
     742,   934,   935,   936,   835,   839,   836,   982,   673,   137,
     138,   139,   140,   141,   142,   143,   144,   200,   145,   194,
     502,   393,   179,   197,   350,   304,   368,   821,   822,   823,
     218,   647,   504,   505,   181,   753,   207,   210,   530,   374,
     600,   302,   461,  1014,   351,   369,   370,   824,   508,   825,
     182,   183,   184,   185,   186,   464,   341,   342,   187,   344,
     348,   307,   510,   361,   203,   159,   298,   188,   189,   938,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     190,   191,   496,   497
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     180,   192,   492,   152,   455,   376,   155,   352,    11,   631,
     632,   633,   629,   630,   232,   741,   843,   357,   528,   500,
     387,   388,   389,   390,   507,   613,   939,   983,   940,   850,
     837,   838,   638,   170,   171,   172,  1047,   853,   854,   165,
    1040,   513,     5,   373,   462,   208,   305,   599,   345,   671,
     335,  1017,   337,   346,     1,   217,  1021,   161,   162,   163,
     164,   381,   233,   228,   229,   235,   220,   466,   170,   171,
     172,   670,   672,  1027,   467,   759,  1074,  1075,   336,   920,
     983,  1070,   470,   166,   371,   983,  1019,   148,     6,   219,
     149,  1045,   503,  1020,   563,   309,   933,  1088,   166,   305,
     168,   169,   332,   333,   334,  1094,   170,   171,   172,  1096,
     309,   941,   616,   166,   297,   168,   169,   305,     7,   917,
     983,   541,   465,  1060,  1059,   615,   170,   171,   172,  1080,
    1061,  1062,  1073,   850,   614,    10,  1081,   932,   625,   626,
     627,   628,   476,   477,   924,   514,   463,   926,   470,   847,
     928,   343,  1086,   471,   490,   146,   339,   609,   170,   171,
     172,   983,   299,   147,   306,   639,   153,   478,   479,   308,
     544,   545,   546,   547,   355,  -424,    12,   330,   331,   649,
    -424,   983,   448,   338,   166,   366,   295,   170,   372,   172,
     158,   465,   310,   311,   177,   178,   309,   151,   349,   353,
     463,   168,   169,   476,   642,   535,   154,   310,   311,   177,
     178,   364,   784,   156,   367,   306,   643,   375,   349,   330,
     331,   338,   310,   311,   177,   178,   765,   371,   478,   479,
     643,   379,   170,   171,   172,   306,   687,   688,   690,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   463,   157,   847,   480,   481,   652,   193,   345,   166,
     493,   494,   495,   346,   863,   718,   864,   482,   483,   484,
     847,   309,   196,   485,   486,   881,   168,   169,   487,   643,
     371,   485,   486,   990,   431,   432,  1018,   991,   199,   166,
     452,   173,   174,   175,   324,   177,   178,   170,   300,   172,
     201,   309,   435,   436,   626,   202,   168,   169,   204,   217,
     474,   475,   744,   745,   286,   287,   288,   289,   290,   206,
     220,   312,   841,   738,   739,   740,   842,   682,   683,   684,
     685,   465,   170,   598,   172,   205,   232,   840,   738,   739,
     740,   689,   691,   219,   209,   439,   440,   332,   333,   211,
     532,   215,   536,   216,   511,   217,   640,   641,   515,   223,
     517,   518,   166,   480,   481,   521,   522,   221,   310,   311,
     177,   178,  1041,  1042,   309,   449,   451,   531,   534,   168,
     169,   537,   538,   539,   542,   222,   217,   918,   919,   506,
     352,   424,   425,   945,   224,   576,   225,   220,   310,   311,
     177,   178,   779,   780,   575,   623,   624,   226,   227,   291,
     294,   306,   343,   295,   340,   358,   585,   362,   360,   363,
     219,   380,   371,   371,   371,   371,   371,   371,   371,   371,
     371,   371,   371,   371,   371,   371,   371,   392,   408,   409,
     410,   411,   412,   413,   414,   601,   447,   415,   416,   453,
     454,   371,   422,   426,   433,   860,   861,   981,   840,   430,
     434,   981,   437,   438,   442,   441,   443,   790,   791,   444,
     445,   310,   311,   177,   178,   446,   448,   456,   457,   469,
     795,   458,   797,   460,   468,   472,   488,   473,   499,   654,
     655,   501,   512,   656,   659,   491,   520,   529,   498,   523,
     540,   526,   668,   543,   548,   463,   564,   646,   567,   827,
     217,   570,   579,   577,   584,   679,   572,   603,   581,   582,
     586,   650,   608,   660,   946,   663,   664,   883,   884,   885,
     587,   948,   888,   297,   949,   465,   611,   637,   987,   988,
     643,   705,   706,   303,   648,   645,   651,   652,   383,   661,
     665,   674,   675,   306,   515,   515,   306,   306,   306,   306,
     306,   306,   306,   306,   306,   306,   306,   306,  1057,   681,
     865,   686,   913,   709,   704,   711,   707,   712,   715,   720,
     727,   716,   719,   725,   746,   749,   752,   724,   891,   756,
     757,   758,   303,  1023,  1024,   760,   765,   641,   604,   605,
     606,   607,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   775,   754,   777,   781,   829,
     787,   855,   617,   618,   959,   960,   961,   962,   792,   421,
     766,   767,   810,   819,   769,   770,   771,   820,   856,   859,
     774,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     851,   862,   993,   866,   644,   786,   868,   870,   869,   871,
     872,   943,   992,   793,   794,   881,   796,   653,   798,   799,
     800,   801,   802,   803,   804,   805,   806,   807,   808,   809,
     923,   925,   927,   929,   930,   303,  1022,   816,   994,   956,
     676,   989,   995,   349,  1044,   349,  1026,  1059,   830,   831,
    1048,  1003,  1004,  1049,  1071,  1063,  1076,  1066,  1077,  1072,
    1084,  1065,  1082,  1083,   815,  1085,  1087,   817,   818,  1090,
    1091,   511,   828,  1093,  1095,  1097,   680,   384,   382,   748,
     834,   293,   601,   601,   601,   601,   947,   921,  1046,   303,
     601,   601,   574,   922,   985,   873,   931,   986,   303,   303,
     878,   303,   519,   880,   717,   826,   533,   509,   743,   325,
     326,   620,   882,   610,   622,   867,   489,   619,   755,   889,
     621,  1058,   890,     0,   892,   893,   894,   895,   896,   347,
       0,   897,     0,   898,   899,   900,     0,     0,     0,     0,
       0,   906,   217,   217,   217,     0,   761,   217,   762,     0,
       0,   349,     0,   220,   220,   220,   763,   764,   220,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   602,   219,   219,   219,   782,
     783,   219,     0,     0,   911,   912,     0,   217,     0,     0,
       0,     0,     0,   303,     0,     0,     0,   601,   220,     0,
     601,     0,     0,   601,   954,     0,   601,     0,   957,   937,
       0,     0,     0,     0,     0,   964,     0,     0,   965,   966,
       0,   219,     0,     0,     0,   967,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   975,     0,     0,   217,
     217,   217,   217,     0,     0,     0,     0,     0,     0,     0,
     220,   220,   220,   220,     0,   602,     0,     0,   303,   303,
       0,   303,     0,     0,     0,     0,   977,     0,     0,     0,
       0,   303,   303,   219,   219,   219,   219,     0,     0,     0,
     997,     0,     0,   999,   937,     0,   601,   601,     0,     0,
       0,     0,  1006,     0,     0,     0,     0,     0,   161,   162,
     163,   164,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   217,   217,   165,   166,
       0,     0,     0,     0,     0,  1030,     0,   220,   220,  1013,
       0,   167,     0,   503,     0,     0,   168,   169,     0,     0,
       0,   601,   601,     0,     0,     0,  1028,   170,   171,   172,
     219,   219,     0,     0,     0,     0,  1050,     0,     0,     0,
       0,   942,     0,     0,     0,     0,     0,  1038,     0,     0,
       0,     0,     0,     0,     0,     0,   937,     0,     0,     0,
       0,     0,     0,     0,     0,   301,     0,     0,     0,     0,
     303,     0,  1078,     0,     0,     0,   303,   303,     0,     0,
     303,     0,     0,   303,     0,     0,     0,     0,     0,     0,
    1089,   303,     0,     0,     0,     0,   937,   937,     0,     0,
       0,     0,     0,     0,     0,     0,   173,   174,   175,   176,
     177,   178,     0,     0,   365,     0,     0,   937,     0,   303,
     303,     0,   303,   303,     0,   937,     0,     0,     0,   937,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   303,
       0,     0,   602,   602,   602,   602,     0,     0,     0,     0,
     602,   602,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1025,     0,     0,     0,     0,
       0,     0,     0,     0,   303,   303,   303,   303,     0,     0,
     303,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   161,   162,   163,   164,   459,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   165,   166,   303,   303,   303,   303,     0,
     303,   303,   303,  1064,     0,     0,   167,     0,     0,     0,
       0,   168,   169,     0,     0,     0,   602,   303,   303,     0,
       0,     0,   170,   171,   172,     0,     0,   602,     0,     0,
     602,   516,     0,   602,     0,     0,   602,     0,     0,     0,
     524,   525,     0,   527,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   303,     0,   303,
     303,   303,     0,   303,     0,     0,     0,   303,     0,     0,
       0,     0,   303,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   303,     0,     0,   303,   303,
     303,   303,   303,   303,     0,   303,     0,     0,     0,   303,
     303,   173,   174,   175,   176,   177,   178,     0,     0,     0,
       0,   984,     0,     0,     0,     0,   602,   602,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   161,   162,   163,
     164,     0,     0,     0,     0,   612,     0,   303,     0,   303,
       0,     0,   303,   303,   303,     0,     0,   303,   166,     0,
       0,     0,   303,   303,   303,   303,     0,   303,   303,     0,
     167,   303,   303,     0,   984,   168,   169,     0,     0,   984,
       0,   602,   602,     0,     0,     0,   170,   171,   172,     0,
       0,   303,     0,     0,     0,   303,   303,   303,   303,     0,
       0,     0,     0,   303,     0,   303,   303,   662,   303,     0,
     666,   667,     0,   669,   984,     0,     0,     0,     0,     0,
       0,     0,     0,   677,   678,   303,   303,   303,   303,     0,
       0,   303,   303,     0,   303,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   303,   303,   303,
       0,   161,   162,   163,   164,   984,     0,     0,     0,     0,
       0,     0,     0,   303,   303,   173,   174,   175,   176,   177,
     178,   165,   166,     0,     0,   984,     0,     0,     0,     0,
       0,     0,     0,   303,   167,     0,    -9,     0,     0,   168,
     169,    13,    14,    15,    16,    17,    18,    19,    20,    21,
     170,   171,   172,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    22,    23,
      24,    25,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   768,     0,    26,     0,    27,    -9,   772,   773,
       0,     0,   776,     0,     0,   778,     0,     0,     0,     0,
       0,     0,     0,   785,     0,     0,     0,     0,     0,     0,
       0,    28,     0,     0,     0,     0,     6,     0,     0,   173,
     174,   657,   176,   177,   178,    29,     0,     0,     0,     0,
       0,   811,   812,     0,   813,   814,     0,     0,     0,     0,
      30,    31,     0,     0,     0,     0,    32,    33,    34,     0,
       0,   833,    35,    36,    37,     0,     0,    38,    39,    40,
      41,    42,     0,     0,     0,     0,    43,    44,    45,    46,
       0,    47,    48,    49,    50,    51,    52,    53,    54,     0,
       0,     0,    55,    56,     0,     0,    57,    58,    59,     0,
       0,     0,     0,     0,     0,     0,   874,   875,   876,   877,
       0,     0,   879,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   161,   162,   163,   164,     0,
      60,    61,     0,     0,   323,   327,   328,   329,     0,     0,
     161,   162,   163,   164,     0,     0,   166,   902,   903,   904,
     905,     0,   907,   908,   909,     0,     0,     0,   167,     0,
     503,   166,     0,   168,   169,     0,     0,     0,   914,   915,
     916,     0,     0,   167,   170,   171,   172,     0,   168,   169,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   170,
     598,   172,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   950,
       0,   951,   952,   953,     0,   955,     0,     0,     0,   958,
       0,     0,     0,     0,   963,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   968,     0,     0,
     969,   970,   971,   972,   973,   974,     0,   976,     0,     0,
       0,   978,   979,   173,   174,   175,   176,   177,   178,   323,
       0,     0,   323,   323,     0,     0,     0,     0,   173,   174,
     175,   176,   177,   178,     0,     0,     0,   327,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   996,
       0,   998,     0,     0,  1000,  1001,  1002,     0,     0,  1005,
       0,     0,     0,     0,  1007,  1008,  1009,  1010,   323,  1011,
    1012,   323,     0,  1015,  1016,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1029,     0,     0,     0,  1031,  1032,  1033,
    1034,     0,     0,     0,     0,  1035,     0,  1036,  1037,     0,
    1039,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1051,  1052,  1053,
    1054,     0,     0,  1055,  1056,     0,  1039,     0,     0,   160,
       0,     0,     0,     0,     0,   195,     0,   198,     0,  1067,
    1068,  1069,     0,     0,     0,     0,     0,     0,     0,     0,
     212,   213,   214,     0,     0,  1079,  1039,     0,     0,     0,
       0,   323,   323,   323,   323,     0,     0,   231,     0,     0,
       0,     0,     0,     0,     0,  1092,     0,     0,     0,     0,
       0,   323,     0,     0,     0,   323,   323,     0,   323,   323,
     323,   323,   323,   323,   323,   323,   323,   323,   323,   323,
     323,   323,   323,   634,   635,   636,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   323,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     323,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   323,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    13,    14,    15,    16,    17,
      18,    19,    20,    21,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   354,     0,     0,   356,     0,     0,   359,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   323,    22,    23,    24,    25,     0,     0,     0,   377,
     378,   323,     0,     0,     0,     0,     0,     0,    26,     0,
      27,   383,   386,     0,     0,     0,     0,   391,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   323,
     323,   323,   407,     0,     0,    28,     0,     0,     0,   323,
     323,     0,   417,   418,   419,   420,     0,     0,     0,    29,
       0,   428,   429,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   323,   323,    30,    31,     0,     0,     0,     0,
      32,    33,    34,     0,     0,     0,    35,    36,    37,     0,
       0,    38,    39,    40,    41,    42,     0,     0,     0,     0,
      43,    44,    45,    46,     0,    47,    48,    49,    50,    51,
      52,    53,    54,     0,     0,     0,    55,    56,     0,     0,
      57,    58,    59,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    60,    61,     0,   323,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,     0,     0,   565,   566,     0,   569,     0,
     571,     0,     0,     0,     0,     0,     0,   578,     0,     0,
       0,     0,     0,   583,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   323,   323,     0,     0,     0,     0,     0,
     323,     0,     0,     0,     0,     0,     0,   323,     0,     0,
     323,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   323,     0,     0,     0,   323,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   708,     0,   710,     0,     0,   713,
     714,     0,     0,     0,     0,     0,     0,   722,   723,     0,
       0,     0,   726,     0,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,     0,     0,     0,     0,   323,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   636,     0,     0,     0,
     323,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   323,
       0,     0,     0,     0,     0,     0,   323,   323,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     323,   323,     0,     0,     0,     0,     0,     0,   788,   789,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   323,     0,     0,     0,     0,     0,     0,     0,   323,
       0,     0,     0,   323,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   234,     0,     0,     0,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      -8,    -8,    -8,    -8,    -8,    -8,     0,     0,     0,     0,
       0,    -8,    -8,    -8,    -8,    -8,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   886,   887,    -8,     0,
      -8,    -8,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   901,     0,     0,     0,
       0,     0,     0,     0,     0,    -8,     0,     0,     0,     0,
       1,     0,     0,     0,     0,   910,     0,     0,     0,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,     0,     0,     0,     0,     0,     0,
       0,    -8,    13,    14,    15,    16,    17,    18,    19,    20,
      21,     0,     0,     0,     0,     0,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    22,
      23,    24,    25,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    26,     0,    27,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    28,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,    29,     0,     0,     0,
       0,   242,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    30,    31,     0,     0,     0,     0,    32,    33,    34,
       0,     0,     0,    35,    36,    37,     0,     0,    38,    39,
      40,    41,    42,     0,     0,     0,     0,    43,    44,    45,
      46,     0,    47,    48,    49,    50,    51,    52,    53,    54,
       0,     0,     0,    55,    56,     0,     0,    57,    58,    59,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,     0,     0,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,     0,     0,     0,   264,
     265,    60,    61,     0,     0,     0,   266,   267,   268,   269,
       0,     0,     0,     0,   270,     0,     0,     0,     0,     0,
       0,     0,     0,   271,   272,   273,     0,     0,   274,   275,
       0,     0,     0,   276,     0,     0,     0,     0,     0,     0,
       0,   277,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   278,   279,   280,   281,
     282,   283,   284,   285
};

static const yytype_int16 yycheck[] =
{
      24,    25,   340,    16,   296,   214,    19,   195,     8,   482,
     483,   484,   480,   481,    62,   599,   732,   201,   371,   344,
     237,   238,   239,   240,   350,    58,     1,   927,     3,   734,
     729,   730,   489,    86,    87,    88,  1022,   736,   737,    57,
    1015,   354,     0,   213,   304,    41,   160,   441,    46,    63,
      58,   980,   179,    51,    90,    50,   985,    37,    38,    39,
      40,   231,    62,   184,   185,    65,    50,    56,    86,    87,
      88,   528,    86,     1,    63,    65,  1062,  1063,    86,   837,
     980,  1056,    72,    58,   211,   985,    56,    86,    90,    50,
      89,  1020,    72,    63,   407,    70,   854,  1083,    58,   213,
      75,    76,    48,    49,    50,  1091,    86,    87,    88,  1095,
      70,    86,   465,    58,   167,    75,    76,   231,    14,   835,
    1020,   381,   306,    56,    56,   463,    86,    87,    88,    56,
      63,    63,  1061,   838,   167,   167,    63,   853,   476,   477,
     478,   479,    53,    54,   843,   354,    53,   846,    72,   733,
     849,    58,  1081,    77,   338,   167,   180,   449,    86,    87,
      88,  1061,   158,    86,   160,   490,    86,    78,    79,   165,
     387,   388,   389,   390,   198,    46,    62,    48,    49,   505,
      51,  1081,    17,   179,    58,   209,    21,    86,   212,    88,
      58,   375,   167,   168,   169,   170,    70,    89,   194,   195,
      53,    75,    76,    53,    54,    58,    86,   167,   168,   169,
     170,   207,    59,    86,   210,   211,    63,   213,   214,    48,
      49,   217,   167,   168,   169,   170,    59,   354,    78,    79,
      63,   227,    86,    87,    88,   231,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,    53,    86,   837,    69,    70,    58,    76,    46,    58,
      48,    49,    50,    51,    61,   578,    63,    82,    83,    84,
     854,    70,    52,    66,    67,    59,    75,    76,    71,    63,
     407,    66,    67,    58,   184,   185,    71,    62,    93,    58,
      89,   165,   166,   167,   168,   169,   170,    86,    87,    88,
      92,    70,   184,   185,   642,    62,    75,    76,    94,   304,
      80,    81,   604,   605,    22,    23,    24,    25,    26,    58,
     304,   166,   177,   178,   179,   180,   181,   544,   545,   546,
     547,   515,    86,    87,    88,    94,   384,   731,   178,   179,
     180,   550,   551,   304,    58,   184,   185,    48,    49,    86,
     374,    89,   376,   167,   350,   350,    63,    64,   354,    94,
     356,   357,    58,    69,    70,   361,   362,    98,   167,   168,
     169,   170,    69,    70,    70,   292,   293,   373,   374,    75,
      76,   377,   378,   379,   384,    98,   381,   174,   175,   350,
     578,   272,   273,    89,    94,   419,    86,   381,   167,   168,
     169,   170,   671,   672,   417,   474,   475,    86,    94,    18,
      68,   407,    58,    21,    53,   167,   429,    95,    58,   167,
     381,   182,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,    36,    62,    94,
      94,     4,    94,    62,    94,   441,   291,     4,     4,   294,
     295,   578,    29,    91,   184,   747,   748,   925,   852,    62,
     184,   929,   184,   184,    47,   185,    19,   684,   685,    19,
      19,   167,   168,   169,   170,    19,    17,    59,    63,    59,
     689,    62,   691,    62,    58,    73,    86,    74,    53,   513,
     514,   164,    58,   517,   518,   340,   167,    58,   343,    63,
     183,    63,   526,   168,   168,    53,   167,   503,    62,   718,
     505,   167,    27,    86,   167,   539,    62,    19,    94,    94,
     167,   505,    60,   519,   862,   521,   522,   787,   788,   789,
     172,   869,   792,   167,   872,   719,   167,    59,   932,   933,
      63,   565,   566,   159,   505,    59,    55,    58,    61,    59,
     167,    58,    58,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,  1041,   167,
     754,   167,   832,   569,    62,   571,   167,   167,   167,    28,
     172,   167,   578,   167,    20,    86,    59,   583,   797,    54,
      56,    59,   208,   987,   988,   167,    59,    64,   443,   444,
     445,   446,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,    59,   612,    63,    59,    94,
     167,    58,   467,   468,   884,   885,   886,   887,   167,   270,
     654,   655,   167,   167,   658,   659,   660,   167,    16,    86,
     664,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     177,    68,   944,    59,   499,   679,    54,    59,    63,    56,
      53,    15,    53,   687,   688,    59,   690,   512,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     176,    55,    55,    55,    55,   301,    63,   711,    54,    59,
     535,    59,    54,   689,   173,   691,   167,    56,   722,   723,
      63,   961,   962,    63,   173,    63,    59,    97,    54,   173,
      96,  1049,    56,    63,   710,   173,   173,   713,   714,    56,
      63,   717,   718,   173,    63,    56,   542,   235,   232,   607,
     726,   154,   728,   729,   730,   731,   864,   838,  1021,   355,
     736,   737,   416,   839,   929,   769,   852,   930,   364,   365,
     774,   367,   359,   777,   578,   718,   374,   350,   603,   167,
     167,   471,   786,   457,   473,   759,   337,   470,   613,   793,
     472,  1042,   796,    -1,   798,   799,   800,   801,   802,   190,
      -1,   805,    -1,   807,   808,   809,    -1,    -1,    -1,    -1,
      -1,   815,   787,   788,   789,    -1,   641,   792,   643,    -1,
      -1,   797,    -1,   787,   788,   789,   651,   652,   792,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   441,   787,   788,   789,   674,
     675,   792,    -1,    -1,   830,   831,    -1,   832,    -1,    -1,
      -1,    -1,    -1,   459,    -1,    -1,    -1,   843,   832,    -1,
     846,    -1,    -1,   849,   878,    -1,   852,    -1,   882,   855,
      -1,    -1,    -1,    -1,    -1,   889,    -1,    -1,   892,   893,
      -1,   832,    -1,    -1,    -1,   899,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   910,    -1,    -1,   884,
     885,   886,   887,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     884,   885,   886,   887,    -1,   521,    -1,    -1,   524,   525,
      -1,   527,    -1,    -1,    -1,    -1,   912,    -1,    -1,    -1,
      -1,   537,   538,   884,   885,   886,   887,    -1,    -1,    -1,
     954,    -1,    -1,   957,   930,    -1,   932,   933,    -1,    -1,
      -1,    -1,   966,    -1,    -1,    -1,    -1,    -1,    37,    38,
      39,    40,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   961,   962,    57,    58,
      -1,    -1,    -1,    -1,    -1,   999,    -1,   961,   962,   975,
      -1,    70,    -1,    72,    -1,    -1,    75,    76,    -1,    -1,
      -1,   987,   988,    -1,    -1,    -1,   992,    86,    87,    88,
     961,   962,    -1,    -1,    -1,    -1,  1030,    -1,    -1,    -1,
      -1,   856,    -1,    -1,    -1,    -1,    -1,  1013,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1022,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   159,    -1,    -1,    -1,    -1,
     656,    -1,  1066,    -1,    -1,    -1,   662,   663,    -1,    -1,
     666,    -1,    -1,   669,    -1,    -1,    -1,    -1,    -1,    -1,
    1084,   677,    -1,    -1,    -1,    -1,  1062,  1063,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   165,   166,   167,   168,
     169,   170,    -1,    -1,   208,    -1,    -1,  1083,    -1,   705,
     706,    -1,   708,   709,    -1,  1091,    -1,    -1,    -1,  1095,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   725,
      -1,    -1,   728,   729,   730,   731,    -1,    -1,    -1,    -1,
     736,   737,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   990,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   770,   771,   772,   773,    -1,    -1,
     776,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    39,    40,   301,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    57,    58,   811,   812,   813,   814,    -1,
     816,   817,   818,  1048,    -1,    -1,    70,    -1,    -1,    -1,
      -1,    75,    76,    -1,    -1,    -1,   832,   833,   834,    -1,
      -1,    -1,    86,    87,    88,    -1,    -1,   843,    -1,    -1,
     846,   355,    -1,   849,    -1,    -1,   852,    -1,    -1,    -1,
     364,   365,    -1,   367,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   873,    -1,   875,
     876,   877,    -1,   879,    -1,    -1,    -1,   883,    -1,    -1,
      -1,    -1,   888,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   901,    -1,    -1,   904,   905,
     906,   907,   908,   909,    -1,   911,    -1,    -1,    -1,   915,
     916,   165,   166,   167,   168,   169,   170,    -1,    -1,    -1,
      -1,   927,    -1,    -1,    -1,    -1,   932,   933,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    39,
      40,    -1,    -1,    -1,    -1,   459,    -1,   953,    -1,   955,
      -1,    -1,   958,   959,   960,    -1,    -1,   963,    58,    -1,
      -1,    -1,   968,   969,   970,   971,    -1,   973,   974,    -1,
      70,   977,   978,    -1,   980,    75,    76,    -1,    -1,   985,
      -1,   987,   988,    -1,    -1,    -1,    86,    87,    88,    -1,
      -1,   997,    -1,    -1,    -1,  1001,  1002,  1003,  1004,    -1,
      -1,    -1,    -1,  1009,    -1,  1011,  1012,   521,  1014,    -1,
     524,   525,    -1,   527,  1020,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   537,   538,  1031,  1032,  1033,  1034,    -1,
      -1,  1037,  1038,    -1,  1040,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1053,  1054,  1055,
      -1,    37,    38,    39,    40,  1061,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1069,  1070,   165,   166,   167,   168,   169,
     170,    57,    58,    -1,    -1,  1081,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1089,    70,    -1,     0,    -1,    -1,    75,
      76,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      86,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,
      44,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   656,    -1,    58,    -1,    60,    61,   662,   663,
      -1,    -1,   666,    -1,    -1,   669,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   677,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    85,    -1,    -1,    -1,    -1,    90,    -1,    -1,   165,
     166,   167,   168,   169,   170,    99,    -1,    -1,    -1,    -1,
      -1,   705,   706,    -1,   708,   709,    -1,    -1,    -1,    -1,
     114,   115,    -1,    -1,    -1,    -1,   120,   121,   122,    -1,
      -1,   725,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,    -1,    -1,    -1,   140,   141,   142,   143,
      -1,   145,   146,   147,   148,   149,   150,   151,   152,    -1,
      -1,    -1,   156,   157,    -1,    -1,   160,   161,   162,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   770,   771,   772,   773,
      -1,    -1,   776,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    39,    40,    -1,
     194,   195,    -1,    -1,   166,   167,   168,   169,    -1,    -1,
      37,    38,    39,    40,    -1,    -1,    58,   811,   812,   813,
     814,    -1,   816,   817,   818,    -1,    -1,    -1,    70,    -1,
      72,    58,    -1,    75,    76,    -1,    -1,    -1,   832,   833,
     834,    -1,    -1,    70,    86,    87,    88,    -1,    75,    76,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,
      87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   873,
      -1,   875,   876,   877,    -1,   879,    -1,    -1,    -1,   883,
      -1,    -1,    -1,    -1,   888,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   901,    -1,    -1,
     904,   905,   906,   907,   908,   909,    -1,   911,    -1,    -1,
      -1,   915,   916,   165,   166,   167,   168,   169,   170,   291,
      -1,    -1,   294,   295,    -1,    -1,    -1,    -1,   165,   166,
     167,   168,   169,   170,    -1,    -1,    -1,   309,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   953,
      -1,   955,    -1,    -1,   958,   959,   960,    -1,    -1,   963,
      -1,    -1,    -1,    -1,   968,   969,   970,   971,   340,   973,
     974,   343,    -1,   977,   978,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   997,    -1,    -1,    -1,  1001,  1002,  1003,
    1004,    -1,    -1,    -1,    -1,  1009,    -1,  1011,  1012,    -1,
    1014,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1031,  1032,  1033,
    1034,    -1,    -1,  1037,  1038,    -1,  1040,    -1,    -1,    23,
      -1,    -1,    -1,    -1,    -1,    29,    -1,    31,    -1,  1053,
    1054,  1055,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      44,    45,    46,    -1,    -1,  1069,  1070,    -1,    -1,    -1,
      -1,   443,   444,   445,   446,    -1,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1089,    -1,    -1,    -1,    -1,
      -1,   463,    -1,    -1,    -1,   467,   468,    -1,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   499,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     512,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   535,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   197,    -1,    -1,   200,    -1,    -1,   203,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   603,    42,    43,    44,    45,    -1,    -1,    -1,   223,
     224,   613,    -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,
      60,    61,   236,    -1,    -1,    -1,    -1,   241,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   641,
     642,   643,   256,    -1,    -1,    85,    -1,    -1,    -1,   651,
     652,    -1,   266,   267,   268,   269,    -1,    -1,    -1,    99,
      -1,   275,   276,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   674,   675,   114,   115,    -1,    -1,    -1,    -1,
     120,   121,   122,    -1,    -1,    -1,   126,   127,   128,    -1,
      -1,   131,   132,   133,   134,   135,    -1,    -1,    -1,    -1,
     140,   141,   142,   143,    -1,   145,   146,   147,   148,   149,
     150,   151,   152,    -1,    -1,    -1,   156,   157,    -1,    -1,
     160,   161,   162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,   195,    -1,   759,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,   410,    -1,   412,    -1,
     414,    -1,    -1,    -1,    -1,    -1,    -1,   421,    -1,    -1,
      -1,    -1,    -1,   427,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   855,   856,    -1,    -1,    -1,    -1,    -1,
     862,    -1,    -1,    -1,    -1,    -1,    -1,   869,    -1,    -1,
     872,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   925,    -1,    -1,    -1,   929,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   568,    -1,   570,    -1,    -1,   573,
     574,    -1,    -1,    -1,    -1,    -1,    -1,   581,   582,    -1,
      -1,    -1,   586,    -1,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,    -1,    -1,    -1,    -1,   990,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1018,    -1,    -1,    -1,
    1022,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1041,
      -1,    -1,    -1,    -1,    -1,    -1,  1048,  1049,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1062,  1063,    -1,    -1,    -1,    -1,    -1,    -1,   682,   683,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1083,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1091,
      -1,    -1,    -1,  1095,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     1,    -1,    -1,    -1,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      30,    31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,
      -1,    41,    42,    43,    44,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   790,   791,    58,    -1,
      60,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   810,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    85,    -1,    -1,    -1,    -1,
      90,    -1,    -1,    -1,    -1,   829,    -1,    -1,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   171,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    58,    -1,    60,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      30,    31,    32,    33,    34,    35,    99,    -1,    -1,    -1,
      -1,    41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   114,   115,    -1,    -1,    -1,    -1,   120,   121,   122,
      -1,    -1,    -1,   126,   127,   128,    -1,    -1,   131,   132,
     133,   134,   135,    -1,    -1,    -1,    -1,   140,   141,   142,
     143,    -1,   145,   146,   147,   148,   149,   150,   151,   152,
      -1,    -1,    -1,   156,   157,    -1,    -1,   160,   161,   162,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,    -1,   116,   117,   118,   119,
      -1,    -1,    -1,   123,   124,   125,    -1,    -1,    -1,   129,
     130,   194,   195,    -1,    -1,    -1,   136,   137,   138,   139,
      -1,    -1,    -1,    -1,   144,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   153,   154,   155,    -1,    -1,   158,   159,
      -1,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   171,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   186,   187,   188,   189,
     190,   191,   192,   193
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    90,   197,   200,   201,     0,    90,    14,   198,   209,
     167,   201,    62,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    42,    43,    44,    45,    58,    60,    85,    99,
     114,   115,   120,   121,   122,   126,   127,   128,   131,   132,
     133,   134,   135,   140,   141,   142,   143,   145,   146,   147,
     148,   149,   150,   151,   152,   156,   157,   160,   161,   162,
     194,   195,   199,   202,   203,   204,   207,   208,   210,   211,
     212,   213,   214,   215,   217,   218,   219,   222,   223,   224,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   256,   257,   258,   259,   260,   261,
     262,   264,   265,   266,   269,   270,   272,   273,   275,   277,
     278,   279,   280,   281,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   315,   316,   317,
     318,   319,   320,   321,   322,   324,   167,    86,    86,    89,
     206,    89,   206,    86,    86,   206,    86,    86,    58,   371,
     371,    37,    38,    39,    40,    57,    58,    70,    75,    76,
      86,    87,    88,   165,   166,   167,   168,   169,   170,   328,
     335,   340,   356,   357,   358,   359,   360,   364,   373,   374,
     386,   387,   335,    76,   325,   371,    52,   329,   371,    93,
     323,    92,    62,   370,    94,    94,    58,   342,   373,    58,
     343,    86,   371,   371,   371,    89,   167,   328,   336,   340,
     357,    98,    98,    94,    94,    86,    86,    94,   184,   185,
     296,   371,   200,   201,     1,   201,    30,    31,    32,    33,
      34,    35,    41,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   116,   117,   118,
     119,   123,   124,   125,   129,   130,   136,   137,   138,   139,
     144,   153,   154,   155,   158,   159,   163,   171,   186,   187,
     188,   189,   190,   191,   192,   193,    22,    23,    24,    25,
      26,    18,   220,   220,    68,    21,   221,   167,   372,   373,
      87,   346,   347,   374,   331,   351,   373,   367,   373,    70,
     167,   168,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   168,   358,   359,   386,   386,   386,
      48,    49,    48,    49,    50,    58,    86,   364,   373,   335,
      53,   362,   363,    58,   365,    46,    51,   389,   366,   373,
     330,   350,   368,   373,   371,   335,   371,   365,   167,   371,
      58,   369,    95,   167,   373,   346,   335,   373,   332,   351,
     352,   364,   335,   331,   345,   373,   366,   371,   371,   373,
     182,   331,   202,    61,   199,   205,   371,   370,   370,   370,
     370,   371,    36,   327,   327,   327,   327,   327,   327,   327,
     327,   327,   327,   327,   327,   327,   327,   371,    62,    94,
      94,     4,    94,    62,    94,     4,     4,   371,   371,   371,
     371,   327,    29,   271,   271,   271,    91,   276,   371,   371,
      62,   184,   185,   184,   184,   184,   185,   184,   184,   184,
     185,   185,    47,    19,    19,    19,    19,   375,    17,   221,
     230,   221,    89,   375,   375,   230,    59,    63,    62,   346,
      62,   348,   336,    53,   361,   365,    56,    63,    58,    59,
      72,    77,    73,    74,    80,    81,    53,    54,    78,    79,
      69,    70,    82,    83,    84,    66,    67,    71,    86,   363,
     365,   375,   382,    48,    49,    50,   388,   389,   375,    53,
     362,   164,   326,    72,   338,   339,   340,   353,   354,   355,
     368,   373,    58,   332,   366,   373,   346,   373,   373,   323,
     167,   373,   373,    63,   346,   346,    63,   346,   361,    58,
     344,   373,   335,   344,   373,    58,   335,   373,   373,   373,
     183,   336,   201,   168,   370,   370,   370,   370,   168,   371,
     371,   371,   371,   371,   371,   371,   371,   371,   371,   371,
     371,   371,   371,   332,   167,   371,   371,    62,   282,   371,
     167,   371,    62,   263,   263,   206,   335,    86,   371,    27,
     267,    94,    94,   371,   167,   206,   167,   172,   297,   297,
     297,   297,   297,   297,   297,   297,   297,   297,    87,   312,
     346,   373,   374,    19,   375,   375,   375,   375,    60,   230,
     372,   167,   346,    58,   167,   382,   361,   375,   375,   378,
     377,   379,   380,   381,   381,   382,   382,   382,   382,   385,
     385,   384,   384,   384,   386,   386,   386,    59,   388,   362,
      63,    64,    54,    63,   375,    59,   373,   337,   340,   353,
     357,    55,    58,   375,   335,   335,   335,   167,   255,   335,
     373,    59,   346,   373,   373,   167,   346,   346,   335,   346,
     388,    63,    86,   314,    58,    58,   375,   346,   346,   335,
     205,   167,   370,   370,   370,   370,   167,   332,   332,   366,
     332,   366,   332,   332,   332,   332,   332,   332,   332,   332,
     332,   332,   332,   332,    62,   335,   335,   167,   371,   373,
     371,   373,   167,   371,   371,   167,   167,   330,   332,   373,
      28,   268,   371,   371,   373,   167,   371,   172,   371,   371,
     371,   371,   371,   371,   371,   371,   371,   371,   178,   179,
     180,   305,   306,   375,   230,   230,    20,   216,   216,    86,
     228,   229,    59,   341,   373,   375,    54,    56,    59,    65,
     167,   375,   375,   375,   375,    59,   335,   335,   346,   335,
     335,   335,   346,   346,   335,    59,   346,    63,   346,   314,
     314,    59,   375,   375,    59,   346,   335,   167,   371,   371,
     370,   370,   167,   335,   335,   366,   335,   366,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     167,   346,   346,   346,   346,   373,   335,   373,   373,   167,
     167,   333,   334,   335,   353,   355,   333,   366,   373,    94,
     335,   335,   274,   346,   373,   310,   312,   310,   310,   311,
     312,   177,   181,   298,   304,   305,   301,   305,   298,   299,
     304,   177,   300,   310,   310,    58,    16,   225,   226,    86,
     230,   230,    68,    61,    63,   365,    59,   376,    54,    63,
      59,    56,    53,   335,   346,   346,   346,   346,   335,   346,
     335,    59,   335,   336,   336,   336,   371,   371,   336,   335,
     335,   366,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   371,   346,   346,   346,   346,   335,   346,   346,   346,
     371,   373,   373,   336,   346,   346,   346,   298,   174,   175,
     301,   299,   300,   176,   310,    55,   310,    55,   310,    55,
      55,   311,   298,   301,   307,   308,   309,   373,   375,     1,
       3,    86,   375,    15,   227,    89,   382,   228,   382,   382,
     346,   346,   346,   346,   335,   346,    59,   335,   346,   336,
     336,   336,   336,   346,   335,   335,   335,   335,   346,   346,
     346,   346,   346,   346,   346,   335,   346,   373,   346,   346,
     303,   385,   313,   347,   374,   303,   309,   312,   312,    59,
      58,    62,    53,   230,    54,    54,   346,   335,   346,   335,
     346,   346,   346,   336,   336,   346,   335,   346,   346,   346,
     346,   346,   346,   373,   349,   346,   346,   313,    71,    56,
      63,   313,    63,   312,   312,   375,   167,     1,   373,   346,
     335,   346,   346,   346,   346,   346,   346,   346,   373,   346,
     349,    69,    70,   302,   173,   313,   302,   307,    63,    63,
     335,   346,   346,   346,   346,   346,   346,   384,   387,    56,
      56,    63,    63,    63,   375,   382,    97,   346,   346,   346,
     349,   173,   173,   313,   307,   307,    59,    54,   335,   346,
      56,    63,    56,    63,    96,   173,   313,   173,   307,   335,
      56,    63,   346,   173,   307,    63,   307,    56
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   196,   197,   198,   199,   199,   200,   200,   201,   201,
     202,   202,   202,   202,   202,   202,   202,   202,   202,   202,
     202,   203,   203,   203,   204,   205,   206,   206,   207,   208,
     209,   210,   210,   210,   210,   210,   210,   211,   212,   213,
     214,   215,   216,   216,   217,   218,   218,   219,   219,   220,
     220,   221,   222,   223,   223,   223,   223,   224,   225,   225,
     226,   226,   226,   226,   227,   227,   227,   228,   228,   228,
     229,   229,   230,   230,   231,   231,   231,   231,   231,   231,
     231,   231,   231,   231,   231,   231,   231,   231,   231,   231,
     231,   231,   231,   231,   231,   231,   231,   231,   231,   231,
     231,   231,   231,   231,   231,   231,   231,   231,   231,   231,
     231,   231,   231,   231,   231,   231,   231,   231,   231,   231,
     231,   231,   231,   231,   231,   232,   233,   233,   233,   233,
     234,   234,   235,   236,   237,   238,   239,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     251,   251,   252,   252,   252,   253,   253,   254,   254,   255,
     256,   257,   258,   259,   260,   260,   260,   260,   260,   261,
     262,   263,   263,   264,   265,   265,   266,   267,   267,   268,
     268,   269,   270,   271,   271,   272,   273,   274,   274,   274,
     275,   276,   276,   277,   278,   279,   279,   279,   280,   281,
     281,   281,   281,   281,   282,   282,   283,   283,   283,   283,
     283,   283,   283,   283,   283,   283,   283,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   296,   297,   297,   297,   298,   299,   299,   300,   301,
     301,   301,   301,   302,   302,   302,   303,   303,   304,   304,
     304,   304,   305,   306,   306,   306,   307,   307,   308,   309,
     309,   309,   310,   310,   311,   312,   312,   313,   313,   314,
     314,   314,   315,   315,   315,   315,   315,   315,   315,   316,
     317,   318,   318,   319,   320,   321,   321,   321,   321,   322,
     322,   322,   322,   322,   322,   322,   322,   323,   323,   324,
     324,   325,   325,   326,   326,   327,   327,   328,   328,   328,
     328,   329,   329,   330,   331,   332,   332,   333,   333,   334,
     334,   335,   335,   335,   336,   336,   337,   337,   337,   338,
     338,   339,   339,   340,   341,   342,   343,   344,   345,   346,
     346,   347,   348,   348,   349,   349,   350,   351,   351,   352,
     353,   353,   354,   355,   356,   356,   357,   357,   357,   357,
     357,   357,   358,   358,   358,   359,   359,   359,   360,   360,
     361,   362,   363,   363,   363,   364,   364,   365,   366,   367,
     368,   369,   369,   370,   371,   371,   372,   373,   373,   374,
     374,   375,   376,   376,   377,   377,   378,   378,   379,   379,
     380,   380,   380,   381,   381,   381,   381,   381,   382,   383,
     383,   383,   383,   384,   384,   384,   385,   385,   385,   385,
     386,   386,   386,   386,   387,   387,   387,   387,   387,   387,
     388,   388,   388,   388,   389,   389
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     5,     1,     3,     1,     2,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     5,     2,     1,     1,     1,     1,     2,     2,
       4,     1,     1,     1,     1,     1,     1,     2,     9,     6,
       6,     7,     0,     2,     7,     4,     3,     5,     4,     0,
       2,     2,     4,     4,     4,     2,     3,     2,     0,     1,
       2,     2,     2,     2,     0,     6,     3,     3,     3,     1,
       3,     1,     0,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     7,     7,     8,     9,
       6,     6,     6,     7,     6,     7,     8,     7,     6,     8,
       8,     4,     4,     6,     5,     4,     7,     7,     7,     6,
       6,     6,     4,     4,     4,     6,     6,     8,     7,     1,
       8,    10,     8,     9,     1,     1,     1,     3,     2,    10,
      13,     0,     2,    10,     9,     8,    12,     0,     1,     0,
       1,     9,    10,     0,     1,     6,     5,     0,     2,     2,
       6,     0,     1,     9,    16,     9,     5,     6,     6,     4,
       9,     9,     7,     7,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     7,     7,
       7,     7,     7,     7,     9,     7,     7,     9,     5,     4,
       1,     1,     0,     1,     2,     7,     9,     1,    14,     5,
       7,     9,    11,     0,     2,     2,     0,     2,     0,     1,
       1,     1,     4,     1,     1,     1,     1,     1,     1,     1,
       3,     6,     2,     2,     2,     1,     1,     1,     1,     0,
       2,     2,     4,     4,     3,     6,     6,     6,     3,     2,
       2,     9,     9,     2,     2,    12,    12,    11,    11,     1,
       2,     1,     1,     2,     1,     2,     1,     0,     1,     0,
       5,     0,     1,     0,     1,     0,     1,     1,     1,     1,
       1,     0,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     5,     7,     4,     4,     1,
       3,     2,     2,     4,     0,     2,     1,     3,     2,     3,
       1,     4,     2,     1,     3,     4,     2,     2,     1,     2,
       1,     2,     1,     2,     2,     1,     2,     2,     3,     4,
       3,     7,     1,     5,     3,     5,     3,     5,     1,     4,
       7,     0,     3,     2,     3,     5,     1,     1,     1,     1,
       1,     1,     5,     1,     3,     1,     3,     1,     3,     1,
       3,     3,     1,     3,     3,     3,     3,     1,     1,     3,
       3,     3,     1,     3,     3,     1,     3,     3,     3,     1,
       2,     2,     2,     1,     1,     1,     3,     2,     4,     1,
       1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (pBuilder, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, pBuilder); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (pBuilder);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, pBuilder);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, CISA_IR_Builder* pBuilder)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], pBuilder);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, pBuilder); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, CISA_IR_Builder* pBuilder)
{
  YY_USE (yyvaluep);
  YY_USE (pBuilder);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (CISA_IR_Builder* pBuilder)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (pBuilder);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* Listing: NewlinesOpt ListingHeader NewlinesOpt Statements NewlinesOpt  */
#line 624 "CISA.y"
                                                                      {
        TRACE("** Listing Complete\n");
        pBuilder->CISA_post_file_parse();
    }
#line 3014 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 23: /* Scope: ScopeStart error  */
#line 654 "CISA.y"
                       {
        PARSE_ERROR_AT((int)(yyvsp[-1].intval), "unclosed scope");
    }
#line 3022 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 24: /* ScopeStart: LBRACE  */
#line 658 "CISA.y"
           {
        pBuilder->CISA_push_decl_scope();
        (yyval.intval) = CISAlineno;
    }
#line 3031 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 25: /* ScopeEnd: RBRACE  */
#line 662 "CISA.y"
                 {pBuilder->CISA_pop_decl_scope();}
#line 3037 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 28: /* DirectiveKernel: DIRECTIVE_KERNEL IdentOrStringLit  */
#line 673 "CISA.y"
    {
        VISAKernel *cisa_kernel = NULL;
        pBuilder->AddKernel(cisa_kernel, (yyvsp[0].string));
    }
#line 3046 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 29: /* DirectiveGlobalFunction: DIRECTIVE_GLOBAL_FUNC IdentOrStringLit  */
#line 681 "CISA.y"
  {
      VISAFunction *cisa_kernel = NULL;
      pBuilder->AddFunction(cisa_kernel, (yyvsp[0].string));
  }
#line 3055 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 30: /* DirectiveVersion: DIRECTIVE_VERSION DEC_LIT DOT DEC_LIT  */
#line 689 "CISA.y"
   {
       pBuilder->CISA_IR_setVersion((unsigned char)(yyvsp[-2].intval), (unsigned char)(yyvsp[0].intval));
   }
#line 3063 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 37: /* DeclFunction: DIRECTIVE_FUNCDECL STRING_LIT  */
#line 703 "CISA.y"
    {
        // do nothing as it's informational only
    }
#line 3071 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 38: /* DeclVariable: DIRECTIVE_DECL IDENT V_TYPE_EQ_G DECL_DATA_TYPE NUM_ELTS_EQ IntExp AlignAttrOpt AliasAttrOpt GenAttrOpt  */
#line 710 "CISA.y"
    {
       ABORT_ON_FAIL(pBuilder->CISA_general_variable_decl(
           (yyvsp[-7].string), (unsigned int)(yyvsp[-3].intval), (yyvsp[-5].type), (yyvsp[-2].align), (yyvsp[-1].alias).aliasname, (yyvsp[-1].alias).offset, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
    }
#line 3081 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 39: /* DeclAddress: DIRECTIVE_DECL IDENT V_TYPE_EQ_A NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 718 "CISA.y"
   {
       ABORT_ON_FAIL(
           pBuilder->CISA_addr_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), ISA_TYPE_UW, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3091 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 40: /* DeclPredicate: DIRECTIVE_DECL IDENT V_TYPE_EQ_P NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 726 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_predicate_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3100 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 41: /* DeclSampler: DIRECTIVE_DECL IDENT V_TYPE_EQ_S NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 733 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_sampler_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), CISAlineno));
   }
#line 3108 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 42: /* VNameEqOpt: %empty  */
#line 736 "CISA.y"
                    {(yyval.string) = "";}
#line 3114 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 43: /* VNameEqOpt: V_NAME_EQ IDENT  */
#line 736 "CISA.y"
                                                 {(yyval.string) = (yyvsp[0].string);}
#line 3120 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 44: /* DeclSurface: DIRECTIVE_DECL IDENT V_TYPE_EQ_T NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 740 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_surface_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3129 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 45: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset InputSize  */
#line 748 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 3137 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 46: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset  */
#line 753 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-1].string), (short)(yyvsp[0].intval), (unsigned short)size, CISAlineno));
    }
#line 3148 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 47: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset InputSize GenAttrOpt  */
#line 765 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_implicit_input_directive(
            (yyvsp[-4].string), (yyvsp[-3].string), (short)(yyvsp[-2].intval), (unsigned short)(yyvsp[-1].intval), CISAlineno));
    }
#line 3157 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 48: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset GenAttrOpt  */
#line 772 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-2].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)size, CISAlineno));
    }
#line 3168 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 49: /* InputOffset: %empty  */
#line 779 "CISA.y"
                    {(yyval.intval) = 0;}
#line 3174 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 50: /* InputOffset: OFFSET_EQ IntExp  */
#line 779 "CISA.y"
                                                 {(yyval.intval) = (yyvsp[0].intval);}
#line 3180 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 51: /* InputSize: SIZE_EQ IntExp  */
#line 780 "CISA.y"
                          {(yyval.intval) = (yyvsp[0].intval);}
#line 3186 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 52: /* DirectiveParameter: DIRECTIVE_PARAMETER IDENT InputSize GenAttrOpt  */
#line 787 "CISA.y"
                                                   {
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), 0, (unsigned short)(yyvsp[-1].intval), CISAlineno));
    }
#line 3194 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 53: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS STRING_LIT  */
#line 793 "CISA.y"
                                                  {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-2].string), (yyvsp[0].string), CISAlineno));
    }
#line 3202 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 54: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS IntExp  */
#line 797 "CISA.y"
                                              {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directiveNum((yyvsp[-2].string), (uint32_t)(yyvsp[0].intval), CISAlineno));
    }
#line 3210 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 55: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT  */
#line 801 "CISA.y"
                                {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[0].string), nullptr, CISAlineno));
    }
#line 3218 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 56: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS  */
#line 805 "CISA.y"
                                       {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-1].string), nullptr, CISAlineno));
    }
#line 3226 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 57: /* DirectiveFunc: DIRECTIVE_FUNC IdentOrStringLit  */
#line 811 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_function_directive((yyvsp[0].string), CISAlineno));
    }
#line 3234 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 58: /* AlignAttrOpt: %empty  */
#line 816 "CISA.y"
                     {(yyval.align) = ALIGN_BYTE;}
#line 3240 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 60: /* Align: ALIGN_EQ ALIGN_KEYWORD  */
#line 818 "CISA.y"
                           { // 2GRF, 32word, ...
        (yyval.align) = (yyvsp[0].align);
    }
#line 3248 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 61: /* Align: ALIGN_EQ IDENT  */
#line 822 "CISA.y"
                   { // e.g. byte, word, dword, qword, GRF, GRFx2
       if (!ParseAlign(pBuilder, (yyvsp[0].string), (yyval.align))) {
           PARSE_ERROR((yyvsp[0].string), ": invalid align value");
       }
    }
#line 3258 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 62: /* Align: ALIGN_EQ IntExp  */
#line 828 "CISA.y"
                    {
        // e.g. %sizeof(GRF) or %sizeof(DECL)
        (yyval.align) = AlignBytesToVisaAlignment((int)(yyvsp[0].intval));
        if ((yyval.align) == ALIGN_UNDEF) {
            PARSE_ERROR("invalid align size (must be 1, 2, 4, 8, ..., 128)");
        }
    }
#line 3270 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 63: /* Align: ALIGN_EQ error  */
#line 836 "CISA.y"
                   {
        PARSE_ERROR("syntax error in align attribute");
    }
#line 3278 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 64: /* AliasAttrOpt: %empty  */
#line 843 "CISA.y"
    {
       (yyval.alias).aliasname = NULL;
       (yyval.alias).offset = 0;
    }
#line 3287 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 65: /* AliasAttrOpt: ALIAS_EQ LANGLE Var COMMA IntExpNRA RANGLE  */
#line 848 "CISA.y"
    {
       (yyval.alias).aliasname = (yyvsp[-3].string);
       (yyval.alias).offset = (int)(yyvsp[-1].intval);
    }
#line 3296 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 66: /* AliasAttrOpt: ALIAS_EQ LANGLE error  */
#line 853 "CISA.y"
    {
       PARSE_ERROR("syntax error in alias attribute");
    }
#line 3304 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 67: /* OneAttr: IDENT EQUALS IntExpNRA  */
#line 859 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), (yyvsp[0].intval), nullptr);
    }
#line 3312 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 68: /* OneAttr: IDENT EQUALS STRING_LIT  */
#line 863 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), 0, (yyvsp[0].string));
    }
#line 3320 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 69: /* OneAttr: IDENT  */
#line 867 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[0].string), 0, nullptr);
    }
#line 3328 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 70: /* AttrOpt: AttrOpt COMMA OneAttr  */
#line 873 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3336 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 71: /* AttrOpt: OneAttr  */
#line 878 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3344 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 72: /* GenAttrOpt: %empty  */
#line 884 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 3352 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 73: /* GenAttrOpt: ATTR_EQ LBRACE AttrOpt RBRACE  */
#line 888 "CISA.y"
    {
        (yyval.intval) = 1;
    }
#line 3360 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 125: /* Label: LABEL  */
#line 950 "CISA.y"
             {pBuilder->CISA_create_label((yyvsp[0].string), CISAlineno);}
#line 3366 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 126: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 955 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3375 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 127: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar PredVar  */
#line 961 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].vISADecl), (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), CISAlineno);
    }
#line 3383 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 128: /* LogicInstruction: Predicate TERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 966 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3392 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 129: /* LogicInstruction: Predicate QUATERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 972 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-8].pred_reg), (yyvsp[-7].opcode), (yyvsp[-6].sat), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size,
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3401 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 130: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 980 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, NULL, CISAlineno);
    }
#line 3410 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 131: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar  */
#line 986 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), NULL, CISAlineno);
    }
#line 3419 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 132: /* MathInstruction_2OPND: Predicate MATH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 993 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3428 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 133: /* MathInstruction_3OPND: Predicate MATH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1000 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3437 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 134: /* ArithInstruction_2OPND: Predicate ARITH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1007 "CISA.y"
    {
        pBuilder->CISA_create_arith_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3446 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 135: /* ArithInstruction_3OPND: Predicate ARITH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1014 "CISA.y"
    {
        MUST_HOLD(!(((yyvsp[-5].opcode) == ISA_LINE) && ((yyvsp[-1].genOperand).type == OPERAND_IMMEDIATE || (yyvsp[-1].genOperand).type == OPERAND_INDIRECT)),
            "wrong type of src0 operand");
        pBuilder->CISA_create_arith_instruction(
            (yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3458 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 136: /* ArithInstruction_4OPND: Predicate ARITH4_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1026 "CISA.y"
     {
         pBuilder->CISA_create_arith_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3467 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 137: /* ArithInstruction_4OPND: Predicate ARITH4_OP2 ExecSize VecDstOperand_G_I VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1033 "CISA.y"
     {
        pBuilder->CISA_create_arith_instruction2((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3476 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 138: /* DpasInstruction: DPAS_OP ExecSize RawOperand RawOperand RawOperand VecSrcOpndSimple  */
#line 1042 "CISA.y"
    {
        pBuilder->CISA_create_dpas_instruction(
            (yyvsp[-5].dpas_info).opcode, (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].genOperand).cisa_gen_opnd,
            (yyvsp[-5].dpas_info).src2Precision, (yyvsp[-5].dpas_info).src1Precision, (yyvsp[-5].dpas_info).depth, (yyvsp[-5].dpas_info).count, CISAlineno);
    }
#line 3487 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 139: /* BfnInstruction: Predicate BFN_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1052 "CISA.y"
    {
        pBuilder->CISA_create_bfn_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].bfn_info).func_ctrl , (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3496 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 140: /* QwScatterInstruction: Predicate QW_SCATTER_OP DOT DEC_LIT ExecSize Var RawOperand RawOperand  */
#line 1058 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_qword_scatter_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (uint32_t)(yyvsp[-4].intval), (yyvsp[-2].string), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3505 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 141: /* BF_CvtInstruction: BF_CVT_OP ExecSize VecDstOperand_G VecSrcOperand_G_IMM  */
#line 1065 "CISA.y"
    {
        pBuilder->CISA_create_bf_cvt_instruction((yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3513 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 142: /* FCvtInstruction: FCVT_OP ExecSize VecDstOperand_G VecSrcOperand_G_IMM  */
#line 1071 "CISA.y"
    {
        pBuilder->CISA_create_fcvt_instruction((yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3521 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 143: /* AntiTrigInstruction: Predicate ANTI_TRIG_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1077 "CISA.y"
    {
        pBuilder->CISA_create_invtri_inst((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3530 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 144: /* AddrAddInstruction: ADDR_ADD_OP ExecSize VecDstOperand_A VecSrcOperand_G_A_AO VecSrcOperand_G_IMM_AO  */
#line 1086 "CISA.y"
    {
        // a grammatically problematic instruction
        //   addr_add (M1_NM, 1) A0(0)<1> &V127 - 0x10...
        //                                        ^^^^ next operand or V127 offset
        pBuilder->CISA_create_address_instruction((yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3542 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 145: /* SetpInstruction: SETP_OP ExecSize PredVar VecSrcOperand_G_I_IMM  */
#line 1096 "CISA.y"
    {
        pBuilder->CISA_create_setp_instruction(
            (yyvsp[-3].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].vISADecl), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3551 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 146: /* SelInstruction: Predicate SEL_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1103 "CISA.y"
    {
        pBuilder->CISA_create_sel_instruction((yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3560 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 147: /* MinInstruction: Predicate MIN_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1110 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(0, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3569 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 148: /* MaxInstruction: Predicate MAX_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1118 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(
            1, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3579 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 149: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM_A_AO  */
#line 1127 "CISA.y"
    {
        pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat),
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3589 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 150: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_A VecSrcOperand_G_I_IMM_A_AO  */
#line 1134 "CISA.y"
    {
        pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat),
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3599 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 151: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I PredVar  */
#line 1141 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_mov_instruction((yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].vISADecl), CISAlineno));
    }
#line 3607 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 152: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand SrcStateOperand  */
#line 1147 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3616 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 153: /* MovsInstruction: MOVS_OP ExecSize VecDstOperand_G SrcStateOperand  */
#line 1153 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3625 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 154: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand VecSrcOperand_G_I_IMM  */
#line 1159 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3634 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 155: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize PredVar VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1177 "CISA.y"
    {
        pBuilder->CISA_create_cmp_instruction((yyvsp[-4].cond_mod), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].vISADecl), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3643 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 156: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1184 "CISA.y"
    {
        // NOTE: predication not permitted.  Apparently the vISA API doesn't allow for predicated compares
        pBuilder->CISA_create_cmp_instruction(
            (yyvsp[-4].cond_mod), ISA_CMP, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3654 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 157: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var MediaInstructionPlaneID VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1194 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-7].opcode), (yyvsp[-6].media_mode), (yyvsp[-5].offset).row, (yyvsp[-5].offset).elem, (int)(yyvsp[-3].intval), (yyvsp[-4].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3664 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 158: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1202 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-6].opcode), (yyvsp[-5].media_mode), (yyvsp[-4].offset).row, (yyvsp[-4].offset).elem, (int)0, (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3674 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 159: /* MediaInstructionPlaneID: DEC_LIT  */
#line 1208 "CISA.y"
                                 {
        MUST_HOLD((yyvsp[0].intval) <= 0xF, "PlaneID must less than 0xF");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 3683 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 160: /* ScatterInstruction: SCATTER_OP ElemNum ExecSize OwordModifier Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1216 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_instruction(
            (yyvsp[-7].opcode), (int)(yyvsp[-6].intval), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].oword_mod), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3693 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 161: /* ScatterTypedInstruction: Predicate SCATTER_TYPED_OP SAMPLER_CHANNEL ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1225 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_typed_instruction(
            (yyvsp[-8].opcode), (yyvsp[-9].pred_reg), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-5].string),
            (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3703 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 162: /* Scatter4ScaledInstruction: Predicate SCATTER4_SCALED_OP SAMPLER_CHANNEL ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1234 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_scaled_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-5].s_channel)), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3713 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 163: /* ScatterScaledInstruction: Predicate SCATTER_SCALED_OP DOT DEC_LIT ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1243 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_scaled_instruction(
            (yyvsp[-7].opcode), (yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (uint32_t) (yyvsp[-5].intval), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3723 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 164: /* SynchronizationInstruction: BARRIER_OP  */
#line 1250 "CISA.y"
               {
        pBuilder->CISA_create_sync_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 3731 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 165: /* SynchronizationInstruction: SBARRIER_SIGNAL  */
#line 1253 "CISA.y"
                      {
        pBuilder->CISA_create_sbarrier_instruction(true, CISAlineno);
    }
#line 3739 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 166: /* SynchronizationInstruction: SBARRIER_WAIT  */
#line 1256 "CISA.y"
                    {
        pBuilder->CISA_create_sbarrier_instruction(false, CISAlineno);
    }
#line 3747 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 167: /* SynchronizationInstruction: NBARRIER_SIGNAL VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1259 "CISA.y"
                                                                  {
        pBuilder->CISA_create_nbarrier(false, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3755 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 168: /* SynchronizationInstruction: NBARRIER_WAIT VecSrcOperand_G_I_IMM  */
#line 1262 "CISA.y"
                                          {
        pBuilder->CISA_create_nbarrier(true, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3763 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 169: /* DwordAtomicInstruction: Predicate DWORD_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand  */
#line 1268 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_dword_atomic_instruction(
            (yyvsp[-9].pred_reg), (yyvsp[-7].atomic_op), (yyvsp[-6].flag), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3772 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 170: /* TypedAtomicInstruction: Predicate TYPED_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1275 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_typed_atomic_instruction(
            (yyvsp[-12].pred_reg), (yyvsp[-10].atomic_op), (yyvsp[-9].flag), (yyvsp[-8].emask_exec_size).emask, (yyvsp[-8].emask_exec_size).exec_size, (yyvsp[-7].string),
            (yyvsp[-6].RawVar), (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3782 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 171: /* Atomic16Opt: %empty  */
#line 1282 "CISA.y"
             {(yyval.flag) = false;}
#line 3788 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 172: /* Atomic16Opt: DOT DEC_LIT  */
#line 1283 "CISA.y"
                  { // .16
        MUST_HOLD(((yyvsp[0].intval) == 16), "only supports 16");
        (yyval.flag) = true;
    }
#line 3797 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 173: /* SampleUnormInstruction: SAMPLE_UNORM_OP SAMPLER_CHANNEL CHANNEL_OUTPUT Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1290 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sampleunorm_instruction(
            (yyvsp[-9].opcode), ChannelMask::createFromAPI((yyvsp[-8].s_channel)), (yyvsp[-7].s_channel_output), (yyvsp[-6].string), (yyvsp[-5].string),
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3807 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 174: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var Var RawOperand RawOperand RawOperand RawOperand  */
#line 1299 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
            (yyvsp[-8].opcode), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (int)(yyvsp[-6].intval), (yyvsp[-5].string), (yyvsp[-4].string),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3817 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 175: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var RawOperand RawOperand RawOperand RawOperand  */
#line 1307 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
           (yyvsp[-7].opcode), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (int)(yyvsp[-5].intval), "", (yyvsp[-4].string),
           (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3827 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 176: /* Sample3dInstruction: Predicate SAMPLE_3D_OP PixelNullMaskEnableOpt CPSEnableOpt NonUniformSamplerEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var Var RawOperand RawOperandArray  */
#line 1317 "CISA.y"
   {
       const bool success = pBuilder->create3DSampleInstruction(
           (yyvsp[-11].pred_reg), (yyvsp[-10].sample3DOp), (yyvsp[-9].pixel_null_mask), (yyvsp[-8].cps), (yyvsp[-7].non_uniform_sampler), ChannelMask::createFromAPI((yyvsp[-6].s_channel)),
           (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[-2].string),
           (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3840 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 177: /* CPSEnableOpt: %empty  */
#line 1326 "CISA.y"
                     {(yyval.cps) = false;}
#line 3846 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 178: /* CPSEnableOpt: CPS  */
#line 1326 "CISA.y"
                                          {(yyval.cps) = true;}
#line 3852 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 179: /* NonUniformSamplerEnableOpt: %empty  */
#line 1328 "CISA.y"
                                   {(yyval.non_uniform_sampler) = false;}
#line 3858 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 180: /* NonUniformSamplerEnableOpt: NON_UNIFORM_SAMPLER  */
#line 1328 "CISA.y"
                                                                       {(yyval.non_uniform_sampler) = true;}
#line 3864 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 181: /* Load3dInstruction: Predicate LOAD_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var RawOperand RawOperandArray  */
#line 1334 "CISA.y"
   {
       const bool success = pBuilder->create3DLoadInstruction(
           (yyvsp[-8].pred_reg), (yyvsp[-7].sample3DOp), (yyvsp[-6].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-5].s_channel)),
           (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].string),
           (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3877 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 182: /* Gather43dInstruction: Predicate SAMPLE4_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var Var RawOperand RawOperandArray  */
#line 1347 "CISA.y"
   {
       const bool success = pBuilder->createSample4Instruction(
          (yyvsp[-9].pred_reg), (yyvsp[-8].sample3DOp), (yyvsp[-7].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size,
          (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[-2].string),
          (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3890 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 183: /* PixelNullMaskEnableOpt: %empty  */
#line 1356 "CISA.y"
                               {(yyval.pixel_null_mask) = false;}
#line 3896 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 184: /* PixelNullMaskEnableOpt: PIXEL_NULL_MASK  */
#line 1356 "CISA.y"
                                                               {(yyval.pixel_null_mask) = true;}
#line 3902 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 185: /* ResInfo3dInstruction: RESINFO_OP_3D SAMPLER_CHANNEL ExecSize Var RawOperand RawOperand  */
#line 1360 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_RESINFO, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-4].s_channel)), (yyvsp[-2].string), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3912 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 186: /* SampleInfo3dInstruction: SAMPLEINFO_OP_3D SAMPLER_CHANNEL ExecSize Var RawOperand  */
#line 1368 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_SAMPLEINFO, (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-3].s_channel)), (yyvsp[-1].string), NULL, (yyvsp[0].RawVar), CISAlineno));
   }
#line 3922 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 187: /* RTWriteOperandParse: %empty  */
#line 1376 "CISA.y"
    {
    }
#line 3929 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 188: /* RTWriteOperandParse: RTWriteOperandParse VecSrcOperand_G_IMM  */
#line 1379 "CISA.y"
    {
        RTRWOperands.push_back((yyvsp[0].genOperand).cisa_gen_opnd);
    }
#line 3937 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 189: /* RTWriteOperandParse: RTWriteOperandParse RawOperand  */
#line 1383 "CISA.y"
    {
        RTRWOperands.push_back((yyvsp[0].RawVar));
    }
#line 3945 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 190: /* RTWriteInstruction: Predicate RTWRITE_OP_3D RTWriteModeOpt ExecSize Var RTWriteOperandParse  */
#line 1388 "CISA.y"
   {
       bool result = pBuilder->CISA_create_rtwrite_3d_instruction(
           (yyvsp[-5].pred_reg), (yyvsp[-3].string), (yyvsp[-2].emask_exec_size).emask, (unsigned int)(yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].string),
           RTRWOperands, CISAlineno);
       RTRWOperands.clear();
       if (!result)
           YYABORT; // already reported
   }
#line 3958 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 191: /* RTWriteModeOpt: %empty  */
#line 1397 "CISA.y"
                       {(yyval.string) = 0;}
#line 3964 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 193: /* URBWriteInstruction: Predicate URBWRITE_OP_3D ExecSize DEC_LIT DEC_LIT RawOperand RawOperand RawOperand RawOperand  */
#line 1402 "CISA.y"
    {
        pBuilder->CISA_create_urb_write_3d_instruction(
            (yyvsp[-8].pred_reg), (yyvsp[-6].emask_exec_size).emask, (unsigned int)(yyvsp[-6].emask_exec_size).exec_size, (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-4].intval),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3974 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 194: /* AVSInstruction: AVS_OP SAMPLER_CHANNEL Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM CNTRL VecSrcOperand_G_I_IMM EXECMODE VecSrcOperand_G_I_IMM RawOperand  */
#line 1410 "CISA.y"
    {
        pBuilder->CISA_create_avs_instruction(
            ChannelMask::createFromAPI((yyvsp[-14].s_channel)), (yyvsp[-13].string), (yyvsp[-12].string),
            (yyvsp[-11].genOperand).cisa_gen_opnd, (yyvsp[-10].genOperand).cisa_gen_opnd, (yyvsp[-9].genOperand).cisa_gen_opnd, (yyvsp[-8].genOperand).cisa_gen_opnd,
            (yyvsp[-7].genOperand).cisa_gen_opnd, (yyvsp[-6].genOperand).cisa_gen_opnd, (yyvsp[-5].genOperand).cisa_gen_opnd, (yyvsp[-4].cntrl), (yyvsp[-3].genOperand).cisa_gen_opnd,
            (yyvsp[-2].execMode), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 3986 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 195: /* VMEInstruction: VME_IME_OP VMEOpndIME Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1422 "CISA.y"
   {
       //     1 - OP
       //     2 - StreamMode, SearchCtrl
       //     3 - Surface
       //     4 - UNIInput
       //     5 - IMEInput
       //     6 - ref0
       //     7 - ref1
       //     8 - CostCenter
       //     9 - Output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_ime_instruction(
            (yyvsp[-8].opcode), (yyvsp[-7].vmeOpndIvb).streamMode, (yyvsp[-7].vmeOpndIvb).searchCtrl, (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-6].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 4004 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 196: /* VMEInstruction: VME_SIC_OP Var RawOperand RawOperand RawOperand  */
#line 1438 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_sic_instruction((yyvsp[-4].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string), (yyvsp[0].RawVar), CISAlineno));
   }
#line 4012 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 197: /* VMEInstruction: VME_FBR_OP VMEOpndFBR Var RawOperand RawOperand RawOperand  */
#line 1444 "CISA.y"
   {
        //    1 - OP
        //    2 - FBRMdMode, FBRSubMbShape, FBRSubPredMode
        //    3 - surface
        //    4 - UNIInput
        //    5 - FBRInput
        //    6 - output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_fbr_instruction((yyvsp[-5].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string),
            (yyvsp[-4].vmeOpndFbr).cisa_fbrMbMode_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubMbShape_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubPredMode_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 4027 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 198: /* OwordInstruction: OWORD_OP OwordModifier ExecSize Var VecSrcOperand_G_I_IMM RawOperand  */
#line 1457 "CISA.y"
    {
        ABORT_ON_FAIL(
            pBuilder->CISA_create_oword_instruction((yyvsp[-5].opcode), (yyvsp[-4].oword_mod), (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 4036 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 199: /* SvmInstruction: SVM_OP ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1465 "CISA.y"
    {
        bool aligned = false;
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-3].opcode), (yyvsp[-2].emask_exec_size).exec_size, aligned,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4046 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 200: /* SvmInstruction: Predicate SVM_SCATTER_OP DOT DEC_LIT DOT DEC_LIT ExecSize RawOperand RawOperand  */
#line 1472 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter_instruction((yyvsp[-8].pred_reg), (SVMSubOpcode)(yyvsp[-7].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-3].intval), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4055 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 201: /* SvmInstruction: Predicate SVM_ATOMIC_OP ATOMIC_SUB_OP AtomicBitwidthOpt ExecSize RawOperand RawOperand RawOperand RawOperand  */
#line 1478 "CISA.y"
    {
        pBuilder->CISA_create_svm_atomic_instruction((yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-6].atomic_op), (unsigned short)(yyvsp[-5].intval),
            (yyvsp[-3].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), (yyvsp[-2].RawVar), CISAlineno);
    }
#line 4064 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 202: /* SvmInstruction: Predicate SVM_GATHER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1484 "CISA.y"
    {
        pBuilder->CISA_create_svm_gather4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4073 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 203: /* SvmInstruction: Predicate SVM_SCATTER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1490 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4082 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 204: /* AtomicBitwidthOpt: %empty  */
#line 1496 "CISA.y"
             {(yyval.intval) = 32;}
#line 4088 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 205: /* AtomicBitwidthOpt: DOT DEC_LIT  */
#line 1497 "CISA.y"
                  {
        MUST_HOLD((yyvsp[0].intval) == 16 || (yyvsp[0].intval) == 32 || (yyvsp[0].intval) == 64, "only supports 16 or 64");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 4097 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 218: /* LscUntypedLoad: Predicate LSC_LOAD_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedAddrOperand  */
#line 1547 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr,     // address
            (yyvsp[-1].lsc_data_operand).shape,    // data
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_data_operand).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0
            nullptr,     // src1
            nullptr,     // src2
            CISAlineno);
    }
#line 4121 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 219: /* LscUntypedStridedLoad: Predicate LSC_LOAD_STRIDED_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedStridedAddrOperand  */
#line 1578 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_strided_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr,     // address
            (yyvsp[-1].lsc_data_operand).shape,    // data
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_data_operand).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0 base
            (yyvsp[0].lsc_addr_operand).regs[1],  // src0 stride
            nullptr,     // src1
            CISAlineno);
    }
#line 4145 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 220: /* LscUntypedBlock2dLoad: Predicate LSC_LOAD_BLOCK2D_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand2D LscUntypedBlock2dAddrOperand  */
#line 1607 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand2d).shape2D.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_block2d_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_data_operand2d).shape2D,  // data shape
            (yyvsp[-1].lsc_data_operand2d).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs,     // src0 surface info / addrs
            nullptr,     // src1
            CISAlineno);
    }
#line 4166 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 221: /* LscUntypedStore: Predicate LSC_STORE_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedAddrOperand LscDataOperand  */
#line 1632 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // SFID
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr,     // address
            (yyvsp[0].lsc_data_operand).shape,    // data
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0
            (yyvsp[0].lsc_data_operand).reg,      // src1
            nullptr,     // src2
            CISAlineno);
    }
#line 4190 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 222: /* LscUntypedStridedStore: Predicate LSC_STORE_STRIDED_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedStridedAddrOperand LscDataOperand  */
#line 1656 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_strided_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // SFID
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr,     // address
            (yyvsp[0].lsc_data_operand).shape,    // data
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0 base
            (yyvsp[-1].lsc_addr_operand).regs[1],  // src0 stride
            (yyvsp[0].lsc_data_operand).reg,      // src1
            CISAlineno);
    }
#line 4214 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 223: /* LscUntypedBlock2dStore: Predicate LSC_STORE_BLOCK2D_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedBlock2dAddrOperand LscDataOperand2D  */
#line 1683 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand2d).shape2D.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_block2d_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_data_operand2d).shape2D,  // data2d
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs,     // src0 addrs
            (yyvsp[0].lsc_data_operand2d).reg,      // src1
            CISAlineno);
    }
#line 4235 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 224: /* LscUntypedAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedAddrOperand LscPayloadReg LscPayloadReg  */
#line 1709 "CISA.y"
    {
        (yyvsp[-4].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-6].lsc_sfid), (yyvsp[-7].lsc_subOpcode), (yyvsp[-3].lsc_data_operand).shape.order, (yyvsp[-4].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-8].pred_reg),  // predicate
            (yyvsp[-7].lsc_subOpcode),                // op
            (yyvsp[-6].lsc_sfid),                // sfid
            (yyvsp[-5].lsc_caching_opts),                // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-4].emask_exec_size).exec_size),
            (yyvsp[-4].emask_exec_size).emask,
            (yyvsp[-2].lsc_addr_operand).addr,     // address info
            (yyvsp[-3].lsc_data_operand).shape,    // data type
            (yyvsp[-2].lsc_addr_operand).surface,  // surface
            (yyvsp[-3].lsc_data_operand).reg,      // dst data
            (yyvsp[-2].lsc_addr_operand).regs[0],  // src0 addr
            (yyvsp[-1].RawVar),          // src1 data
            (yyvsp[0].RawVar),          // src2 data (for icas/fcas)
            CISAlineno);
    }
#line 4259 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 225: /* LscTypedLoad: Predicate LSC_LOAD_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscTypedAddrOperand  */
#line 1743 "CISA.y"
    {
        if ((yyvsp[-5].lsc_subOpcode) != LSC_LOAD_QUAD) {
            PARSE_ERROR("unsupported load operation for .tgm");
        }
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr.type,  // address model
            (yyvsp[0].lsc_addr_operand).addr.size,  // address size
            (yyvsp[-1].lsc_data_operand).shape,    // data type
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_data_operand).reg,      // dst data
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0_u
            (yyvsp[0].lsc_addr_operand).regs[1],  // src0_v
            (yyvsp[0].lsc_addr_operand).regs[2],  // src0_r
            (yyvsp[0].lsc_addr_operand).regs[3],  // src0_lod
            nullptr,     // src1 data
            nullptr,     // src2 data
            CISAlineno);
    }
#line 4290 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 226: /* LscTypedStore: Predicate LSC_STORE_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscTypedAddrOperand LscDataOperand  */
#line 1783 "CISA.y"
    {
        if ((yyvsp[-5].lsc_subOpcode) != LSC_STORE_QUAD) {
            PARSE_ERROR("unsupported store operation for .tgm");
        }
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr.type,  // address model
            (yyvsp[-1].lsc_addr_operand).addr.size,  // address size
            (yyvsp[0].lsc_data_operand).shape,    // data type
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0_u
            (yyvsp[-1].lsc_addr_operand).regs[1],  // src0_v
            (yyvsp[-1].lsc_addr_operand).regs[2],  // src0_r
            (yyvsp[-1].lsc_addr_operand).regs[3],  // src0_lod
            (yyvsp[0].lsc_data_operand).reg,      // src1 data
            nullptr,     // src2 data
            CISAlineno);
    }
#line 4321 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 227: /* LscTypedAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscTypedAddrOperand LscPayloadReg LscPayloadReg  */
#line 1823 "CISA.y"
    {
        (yyvsp[-4].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-6].lsc_sfid), (yyvsp[-7].lsc_subOpcode), (yyvsp[-3].lsc_data_operand).shape.order, (yyvsp[-4].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-8].pred_reg),  // predicate
            (yyvsp[-7].lsc_subOpcode),  // subop
            (yyvsp[-6].lsc_sfid),  // sfid
            (yyvsp[-5].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-4].emask_exec_size).exec_size),
            (yyvsp[-4].emask_exec_size).emask,
            (yyvsp[-2].lsc_addr_operand).addr.type, // address model
            (yyvsp[-2].lsc_addr_operand).addr.size,  // address size
            (yyvsp[-3].lsc_data_operand).shape,    // data type
            (yyvsp[-2].lsc_addr_operand).surface,  // surface
            (yyvsp[-3].lsc_data_operand).reg,      // dst data
            (yyvsp[-2].lsc_addr_operand).regs[0],  // src0 addrs u
            (yyvsp[-2].lsc_addr_operand).regs[1],  // src0 addrs v
            (yyvsp[-2].lsc_addr_operand).regs[2],  // src0 addrs r
            (yyvsp[-2].lsc_addr_operand).regs[3],  // src0 addrs lod
            (yyvsp[-1].RawVar),          // src1 data
            (yyvsp[0].RawVar),          // src2 data
            CISAlineno);
    }
#line 4349 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 228: /* LscTypedReadStateInfo: Predicate LSC_READ_STATE_INFO_MNEMONIC LSC_SFID_TYPED_TOKEN LscPayloadReg LscRegAddrModel  */
#line 1854 "CISA.y"
   {
        LSC_CACHE_OPTS caching{LSC_CACHING_DEFAULT,LSC_CACHING_DEFAULT};
        LSC_DATA_SHAPE dataShape{LSC_DATA_SIZE_32b,LSC_DATA_ORDER_NONTRANSPOSE};
        dataShape.elems = LSC_DATA_ELEMS_1;
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-4].pred_reg),              // predicate
            (yyvsp[-3].lsc_subOpcode),              // subop
            (yyvsp[-2].lsc_sfid),              // sfid
            caching,         // caching settings
            EXEC_SIZE_1,
            vISA_EMASK_M1_NM,
            (yyvsp[0].lsc_addr_model).type,           // address model
            LSC_ADDR_SIZE_32b, // address size
            dataShape,         // data type
            (yyvsp[0].lsc_addr_model).surface,        // surface
            (yyvsp[-1].RawVar),                // dst data
            nullptr,           // src0 addrs u
            nullptr,           // src0 addrs v
            nullptr,           // src0 addrs r
            nullptr,           // src0 addrs lod
            nullptr,           // src1 data
            nullptr,           // src2 data
            CISAlineno);
   }
#line 4378 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 229: /* LscFence: LSC_FENCE_MNEMONIC LscSfid LSC_FENCE_OP_TYPE LSC_FENCE_SCOPE  */
#line 1887 "CISA.y"
    {
        pBuilder->CISA_create_lsc_fence((yyvsp[-2].lsc_sfid), (yyvsp[-1].lsc_fence_op), (yyvsp[0].lsc_scope), CISAlineno);
    }
#line 4386 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 232: /* LscCacheOpts: %empty  */
#line 1894 "CISA.y"
                                    {(yyval.lsc_caching_opts) = {LSC_CACHING_DEFAULT,LSC_CACHING_DEFAULT};}
#line 4392 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 233: /* LscCacheOpts: LSC_CACHING_OPT  */
#line 1895 "CISA.y"
                                    {(yyval.lsc_caching_opts) = {(yyvsp[0].lsc_caching_opt),LSC_CACHING_DEFAULT};}
#line 4398 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 234: /* LscCacheOpts: LSC_CACHING_OPT LSC_CACHING_OPT  */
#line 1896 "CISA.y"
                                    {(yyval.lsc_caching_opts) = {(yyvsp[-1].lsc_caching_opt),(yyvsp[0].lsc_caching_opt)};}
#line 4404 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 235: /* LscUntypedAddrOperand: LscAddrModelOpt LBRACK LscAddrImmScaleOpt LscPayloadNonNullReg LscAddrImmOffsetOpt RBRACK LSC_ADDR_SIZE_TK  */
#line 1903 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-6].lsc_addr_model).surface,{(yyvsp[-3].RawVar)},{(yyvsp[-6].lsc_addr_model).type,(int)(yyvsp[-4].intval),(int)(yyvsp[-2].intval),(yyvsp[0].lsc_addr_size)}};
    }
#line 4412 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 236: /* LscUntypedStridedAddrOperand: LscAddrModelOpt LBRACK LscAddrImmScaleOpt LscPayloadNonNullReg LscAddrImmOffsetOpt COMMA LscVectorOpRegOrImm RBRACK LSC_ADDR_SIZE_TK  */
#line 1912 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-8].lsc_addr_model).surface,{(yyvsp[-5].RawVar),(yyvsp[-2].lsc_addr_surface_ident)},{(yyvsp[-8].lsc_addr_model).type,(int)(yyvsp[-6].intval),(int)(yyvsp[-4].intval),(yyvsp[0].lsc_addr_size)}};
    }
#line 4420 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 237: /* LscUntypedStridedAddrOperand: LscUntypedAddrOperand  */
#line 1915 "CISA.y"
                            {
        (yyval.lsc_addr_operand) = (yyvsp[0].lsc_addr_operand);
        (yyval.lsc_addr_operand).regs[1] = nullptr;
    }
#line 4429 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 238: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg COMMA LscVectorOpRegOrImm COMMA LscVectorOpRegOrImm COMMA LscVectorOpRegOrImm COMMA LscVectorOpRegOrImm COMMA LscVectorOpRegOrImm RBRACK  */
#line 1938 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {nullptr,{(yyvsp[-11].lsc_addr_surface_ident),(yyvsp[-9].lsc_addr_surface_ident),(yyvsp[-7].lsc_addr_surface_ident),(yyvsp[-5].lsc_addr_surface_ident),(yyvsp[-3].lsc_addr_surface_ident),(yyvsp[-1].lsc_addr_surface_ident)},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4437 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 239: /* LscTypedAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg RBRACK LSC_ADDR_SIZE_TK  */
#line 1951 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-4].lsc_addr_model).surface,{(yyvsp[-2].RawVar)},{(yyvsp[-4].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4445 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 240: /* LscTypedAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg COMMA LscPayloadNonNullReg RBRACK LSC_ADDR_SIZE_TK  */
#line 1962 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-6].lsc_addr_model).surface,{(yyvsp[-4].RawVar),(yyvsp[-2].RawVar)},{(yyvsp[-6].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4453 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 241: /* LscTypedAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg COMMA LscPayloadNonNullReg COMMA LscPayloadNonNullReg RBRACK LSC_ADDR_SIZE_TK  */
#line 1973 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-8].lsc_addr_model).surface,{(yyvsp[-6].RawVar),(yyvsp[-4].RawVar),(yyvsp[-2].RawVar)},{(yyvsp[-8].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4461 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 242: /* LscTypedAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg COMMA LscPayloadNonNullReg COMMA LscPayloadNonNullReg COMMA LscPayloadNonNullReg RBRACK LSC_ADDR_SIZE_TK  */
#line 1984 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-10].lsc_addr_model).surface,{(yyvsp[-8].RawVar),(yyvsp[-6].RawVar),(yyvsp[-4].RawVar),(yyvsp[-2].RawVar)},{(yyvsp[-10].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4469 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 243: /* LscAddrImmOffsetOpt: %empty  */
#line 1992 "CISA.y"
                     {(yyval.intval) =   0;}
#line 4475 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 244: /* LscAddrImmOffsetOpt: PLUS IntExpAdd  */
#line 1993 "CISA.y"
                     {(yyval.intval) =  (yyvsp[0].intval);}
#line 4481 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 245: /* LscAddrImmOffsetOpt: MINUS IntExpPrim  */
#line 1994 "CISA.y"
                     {(yyval.intval) = -(yyvsp[0].intval);}
#line 4487 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 246: /* LscAddrImmScaleOpt: %empty  */
#line 2001 "CISA.y"
                      {(yyval.intval) = 1;}
#line 4493 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 247: /* LscAddrImmScaleOpt: IntExpMul TIMES  */
#line 2002 "CISA.y"
                      {(yyval.intval) = (yyvsp[-1].intval);}
#line 4499 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 248: /* LscAddrModelOpt: %empty  */
#line 2005 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_FLAT,nullptr};}
#line 4505 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 249: /* LscAddrModelOpt: LSC_AM_FLAT  */
#line 2006 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_FLAT,nullptr};}
#line 4511 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 250: /* LscAddrModelOpt: LSC_AM_ARG  */
#line 2007 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_ARG,nullptr};}
#line 4517 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 252: /* LscRegAddrModel: LscRegAddrModelKind LPAREN LscVectorOpRegOrImm RPAREN  */
#line 2012 "CISA.y"
                                                             {
        (yyval.lsc_addr_model) = {(yyvsp[-3].lsc_addr_type),(yyvsp[-1].lsc_addr_surface_ident)};
    }
#line 4525 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 253: /* LscRegAddrModelKind: LSC_AM_BSS  */
#line 2017 "CISA.y"
               {(yyval.lsc_addr_type) = LSC_ADDR_TYPE_BSS;}
#line 4531 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 254: /* LscRegAddrModelKind: LSC_AM_SS  */
#line 2018 "CISA.y"
               {(yyval.lsc_addr_type) = LSC_ADDR_TYPE_SS;}
#line 4537 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 255: /* LscRegAddrModelKind: LSC_AM_BTI  */
#line 2019 "CISA.y"
               {(yyval.lsc_addr_type) = LSC_ADDR_TYPE_BTI;}
#line 4543 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 258: /* LscVectorOpImm: IntExp  */
#line 2024 "CISA.y"
           {
        (yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_immed((yyvsp[0].intval),ISA_TYPE_UD, CISAlineno);
    }
#line 4551 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 259: /* LscVectorOpReg: Var  */
#line 2029 "CISA.y"
        {
        ABORT_ON_FAIL((yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[0].string),
            0, 1, 0, // region
            0, 0, // row and col offset
            MODIFIER_NONE, CISAlineno));
    }
#line 4563 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 260: /* LscVectorOpReg: Var DOT DEC_LIT  */
#line 2037 "CISA.y"
                    {
        ABORT_ON_FAIL((yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-2].string),
            0, 1, 0, // region
            0, (unsigned char)(yyvsp[0].intval), // row and col offset
            MODIFIER_NONE, CISAlineno));
    }
#line 4575 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 261: /* LscVectorOpReg: Var LPAREN IntExp COMMA IntExp RPAREN  */
#line 2045 "CISA.y"
                                          {
        MUST_HOLD((yyvsp[-3].intval) <= 255 || (yyvsp[-3].intval) >= 0, "row is out of bounds");
        MUST_HOLD((yyvsp[-1].intval) <= 255 || (yyvsp[-1].intval) >= 0, "col is out of bounds");
        (yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-5].string),
            0, 1, 0,
            (unsigned char)(yyvsp[-3].intval), (unsigned char)(yyvsp[-1].intval), // row and col offset
            MODIFIER_NONE, CISAlineno);
        if ((yyval.lsc_addr_surface_ident) == nullptr) {
            PARSE_ERROR("cannot find surface variable");
        }
    }
#line 4592 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 262: /* LscDataOperand: LscPayloadReg LSC_DATA_SHAPE_TK  */
#line 2059 "CISA.y"
                                     {
        (yyval.lsc_data_operand) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape)};
    }
#line 4600 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 263: /* LscDataOperand: LscPayloadReg LSC_DATA_SHAPE_TK_CHMASK  */
#line 2063 "CISA.y"
                                            {
        (yyval.lsc_data_operand) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape)};
    }
#line 4608 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 264: /* LscDataOperand2D: LscPayloadReg LSC_DATA_SHAPE_TK_BLOCK2D  */
#line 2069 "CISA.y"
                                            {
        (yyval.lsc_data_operand2d) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape2d)};
    }
#line 4616 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 266: /* LscPayloadReg: Var  */
#line 2077 "CISA.y"
        {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[0].string), 0, CISAlineno));
    }
#line 4624 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 268: /* LscPayloadNonNullReg: VarNonNull  */
#line 2084 "CISA.y"
               {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[0].string), 0, CISAlineno));
    }
#line 4632 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 269: /* SwitchLabels: %empty  */
#line 2090 "CISA.y"
    {
    }
#line 4639 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 270: /* SwitchLabels: COMMA SwitchLabels  */
#line 2093 "CISA.y"
    {
    }
#line 4646 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 271: /* SwitchLabels: IDENT SwitchLabels  */
#line 2096 "CISA.y"
    {
        // parse rule means we see last label first
        switchLabels.push_front((yyvsp[-1].string));
    }
#line 4655 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 272: /* BranchInstruction: Predicate BRANCH_OP ExecSize IdentOrStringLit  */
#line 2103 "CISA.y"
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].opcode), (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), false, CISAlineno);
    }
#line 4663 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 273: /* BranchInstruction: Predicate CALL_OP ExecSize IdentOrStringLit  */
#line 2107 "CISA.y"
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].cisa_call).opcode, (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), (yyvsp[-2].cisa_call).is_fccall, CISAlineno);
    }
#line 4671 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 274: /* BranchInstruction: Predicate RET_OP ExecSize  */
#line 2111 "CISA.y"
    {
        pBuilder->CISA_Create_Ret((yyvsp[-2].pred_reg), (yyvsp[-1].opcode), (yyvsp[0].emask_exec_size).emask, (yyvsp[0].emask_exec_size).exec_size, CISAlineno);
    }
#line 4679 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 275: /* BranchInstruction: SWITCHJMP_OP ExecSize VecSrcOperand_G_I_IMM LPAREN SwitchLabels RPAREN  */
#line 2115 "CISA.y"
    {
        pBuilder->CISA_create_switch_instruction((yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, switchLabels, CISAlineno);
        switchLabels.clear();
    }
#line 4688 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 276: /* BranchInstruction: Predicate FCALL ExecSize IDENT DEC_LIT DEC_LIT  */
#line 2121 "CISA.y"
    {
        pBuilder->CISA_create_fcall_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4696 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 277: /* BranchInstruction: Predicate IFCALL ExecSize VecSrcOperand_G_I_IMM DEC_LIT DEC_LIT  */
#line 2126 "CISA.y"
    {
        pBuilder->CISA_create_ifcall_instruction(
        (yyvsp[-5].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
        (yyvsp[-2].genOperand).cisa_gen_opnd, (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4706 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 278: /* BranchInstruction: FADDR IDENT VecDstOperand_G_I  */
#line 2133 "CISA.y"
    {
        pBuilder->CISA_create_faddr_instruction((yyvsp[-1].string), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 4714 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 279: /* FILE: FILE_OP STRING_LIT  */
#line 2138 "CISA.y"
    {
        pBuilder->CISA_create_FILE_instruction((yyvsp[-1].opcode), (yyvsp[0].string), CISAlineno);
    }
#line 4722 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 280: /* LOC: LOC_OP DEC_LIT  */
#line 2143 "CISA.y"
    {
        pBuilder->CISA_create_LOC_instruction((yyvsp[-1].opcode), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4730 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 281: /* RawSendInstruction: Predicate RAW_SEND_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 2149 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, false, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4739 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 282: /* RawSendInstruction: Predicate RAW_SENDC_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 2156 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, true, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4748 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 283: /* LifetimeStartInst: LIFETIME_START_OP IDENT  */
#line 2163 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)0, (yyvsp[0].string), CISAlineno));
    }
#line 4756 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 284: /* LifetimeEndInst: LIFETIME_END_OP IDENT  */
#line 2169 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)1, (yyvsp[0].string), CISAlineno));
    }
#line 4764 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 285: /* RawSendsInstruction: Predicate RAW_SENDS_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2175 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4775 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 286: /* RawSendsInstruction: Predicate RAW_SENDS_EOT_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2183 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4786 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 287: /* RawSendsInstruction: Predicate RAW_SENDSC_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2191 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4797 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 288: /* RawSendsInstruction: Predicate RAW_SENDSC_EOT_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2199 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4808 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 289: /* NullaryInstruction: CACHE_FLUSH_OP  */
#line 2208 "CISA.y"
    {
        pBuilder->CISA_create_NO_OPND_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 4816 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 290: /* NullaryInstruction: WAIT_OP VecSrcOperand_G_IMM  */
#line 2213 "CISA.y"
    {
        pBuilder->CISA_create_wait_instruction((yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 4824 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 291: /* NullaryInstruction: YIELD_OP  */
#line 2218 "CISA.y"
    {
        pBuilder->CISA_create_yield_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 4832 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 292: /* NullaryInstruction: FENCE_GLOBAL_OP  */
#line 2223 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x0, CISAlineno);
    }
#line 4840 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 293: /* NullaryInstruction: FENCE_GLOBAL_OP FENCE_OPTIONS  */
#line 2228 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options), CISAlineno);
    }
#line 4848 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 294: /* NullaryInstruction: FENCE_LOCAL_OP  */
#line 2233 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x20, CISAlineno);
    }
#line 4856 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 295: /* NullaryInstruction: FENCE_LOCAL_OP FENCE_OPTIONS  */
#line 2238 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options) | 0x20, CISAlineno);
    }
#line 4864 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 296: /* NullaryInstruction: FENCE_SW_OP  */
#line 2243 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x80, CISAlineno);
    }
#line 4872 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 297: /* OwordModifier: %empty  */
#line 2247 "CISA.y"
                      {(yyval.oword_mod) = false;}
#line 4878 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 299: /* Predicate: %empty  */
#line 2254 "CISA.y"
    {
        (yyval.pred_reg) = NULL;
    }
#line 4886 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 300: /* Predicate: LPAREN PredSign PredVar PredCtrlOpt RPAREN  */
#line 2259 "CISA.y"
    {
        (yyval.pred_reg) = pBuilder->CISA_create_predicate_operand((yyvsp[-2].vISADecl), (yyvsp[-3].pred_sign), (yyvsp[-1].pred_ctrl), CISAlineno);
    }
#line 4894 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 301: /* PredSign: %empty  */
#line 2263 "CISA.y"
                 {(yyval.pred_sign) = PredState_NO_INVERSE;}
#line 4900 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 302: /* PredSign: BANG  */
#line 2263 "CISA.y"
                                                     {(yyval.pred_sign) = PredState_INVERSE;}
#line 4906 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 303: /* PredCtrlOpt: %empty  */
#line 2265 "CISA.y"
                    {(yyval.pred_ctrl) = PRED_CTRL_NON;}
#line 4912 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 305: /* SatModOpt: %empty  */
#line 2268 "CISA.y"
                  {(yyval.sat) = false;}
#line 4918 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 306: /* SatModOpt: SAT  */
#line 2268 "CISA.y"
                                      {(yyval.sat) = true;}
#line 4924 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 307: /* SrcModifier: SRCMOD_NEG  */
#line 2271 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG;}
#line 4930 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 308: /* SrcModifier: SRCMOD_ABS  */
#line 2272 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_ABS;}
#line 4936 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 309: /* SrcModifier: SRCMOD_NEGABS  */
#line 2273 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG_ABS;}
#line 4942 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 310: /* SrcModifier: SRCMOD_NOT  */
#line 2274 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NOT;}
#line 4948 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 311: /* ConditionalModifier: %empty  */
#line 2276 "CISA.y"
                            {(yyval.cond_mod) = ISA_CMP_UNDEF;}
#line 4954 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 313: /* VecDstOperand_A: DstAddrOperand  */
#line 2281 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 4960 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 314: /* VecDstOperand_G: DstGeneralOperand  */
#line 2282 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 4966 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 315: /* VecDstOperand_G_I: DstGeneralOperand  */
#line 2284 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 4972 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 316: /* VecDstOperand_G_I: DstIndirectOperand  */
#line 2285 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 4978 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 318: /* VecSrcOperand_G_I_IMM_A_AO: SrcAddrOfOperand  */
#line 2290 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 4984 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 320: /* VecSrcOperand_G_I_IMM_A: SrcAddrOperand  */
#line 2294 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 4990 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 322: /* VecSrcOperand_G_I_IMM: SrcIndirectOperand  */
#line 2298 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 4996 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 323: /* VecSrcOperand_G_I_IMM: SrcImmOperand  */
#line 2299 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5002 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 325: /* VecSrcOperand_G_IMM: SrcImmOperand  */
#line 2303 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5008 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 327: /* VecSrcOperand_G_IMM_AO: SrcImmOperand  */
#line 2307 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5014 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 328: /* VecSrcOperand_G_IMM_AO: SrcAddrOfOperand  */
#line 2308 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 5020 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 330: /* VecSrcOperand_G_A: SrcAddrOperand  */
#line 2312 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5026 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 332: /* VecSrcOperand_G_A_AO: SrcAddrOfOperand  */
#line 2316 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5032 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 333: /* VecSrcOperand_G: SrcGeneralOperand  */
#line 2318 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5038 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 334: /* VecSrcOpndSimple: Var TwoDimOffset  */
#line 2321 "CISA.y"
    {
        // simple vector operand with no modifier that has an
        // implicit src region = <1,1,0>
        (yyval.genOperand).type = OPERAND_GENERAL;
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-1].string), 1, 1, 0, (yyvsp[0].offset).row, (yyvsp[0].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 5050 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 335: /* VMEOpndIME: LPAREN DEC_LIT COMMA DEC_LIT RPAREN  */
#line 2331 "CISA.y"
    {
        (yyval.vmeOpndIvb).streamMode = (unsigned char)(yyvsp[-3].intval);
        (yyval.vmeOpndIvb).searchCtrl = (unsigned char)(yyvsp[-1].intval);
    }
#line 5059 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 336: /* VMEOpndFBR: LPAREN VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM RPAREN  */
#line 2338 "CISA.y"
    {
        (yyval.vmeOpndFbr).cisa_fbrMbMode_opnd = (yyvsp[-5].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubMbShape_opnd = (yyvsp[-3].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubPredMode_opnd = (yyvsp[-1].genOperand).cisa_gen_opnd;
    }
#line 5069 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 337: /* SrcStateOperand: Var LPAREN IntExp RPAREN  */
#line 2346 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, false));
    }
#line 5079 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 338: /* DstStateOperand: Var LPAREN IntExp RPAREN  */
#line 2354 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, true));
    }
#line 5089 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 340: /* RawOperand: BUILTIN_NULL DOT DEC_LIT  */
#line 2385 "CISA.y"
    {
        MUST_HOLD((yyvsp[0].intval) == 0, "%null must have 0 as offset");
        (yyval.RawVar) = pBuilder->CISA_create_RAW_NULL_operand(CISAlineno); // can't fail
    }
#line 5098 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 341: /* RawOperandNonNull: VarNonNull RawOperandOffsetSuffix  */
#line 2392 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[-1].string), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5106 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 342: /* RawOperandOffsetSuffix: DOT DEC_LIT  */
#line 2403 "CISA.y"
                {
        MUST_HOLD((yyvsp[0].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 5115 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 343: /* RawOperandOffsetSuffix: DOT LPAREN IntExp RPAREN  */
#line 2408 "CISA.y"
                             {
        MUST_HOLD((yyvsp[-1].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5124 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 344: /* RawOperandArray: %empty  */
#line 2416 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 5132 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 345: /* RawOperandArray: RawOperandArray RawOperand  */
#line 2421 "CISA.y"
    {
        rawOperandArray[(yyvsp[-1].intval)++] = (VISA_RawOpnd*)(yyvsp[0].RawVar);
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5141 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 346: /* DstAddrOperand: AddrVarAccessWithWidth  */
#line 2429 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
          pBuilder->CISA_set_address_operand(
            (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, true, CISAlineno));
    }
#line 5151 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 347: /* DstGeneralOperand: Var TwoDimOffset DstRegion  */
#line 2437 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-2].string), (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5160 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 348: /* DstGeneralOperand: Var DstRegion  */
#line 2442 "CISA.y"
                  {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-1].string), 0, 0, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5169 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 349: /* DstIndirectOperand: IndirectVarAccess DstRegion DataType  */
#line 2448 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_indirect_dst(
            (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff, (unsigned short)(yyvsp[-1].intval), (yyvsp[0].type), CISAlineno));
    }
#line 5178 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 350: /* SrcAddrOfOperand: AddrOfVar  */
#line 2469 "CISA.y"
              {
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[0].regAccess).cisa_decl, 0, CISAlineno);
    }
#line 5186 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 351: /* SrcAddrOfOperand: AddrOfVar LBRACK IntExp RBRACK  */
#line 2473 "CISA.y"
                                   {
         MUST_HOLD((short)(yyvsp[-1].intval) == (yyvsp[-1].intval), "variable address offset is too large");
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[-3].regAccess).cisa_decl, (short)(yyvsp[-1].intval), CISAlineno);
    }
#line 5195 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 352: /* AddrOfVar: AMP Var  */
#line 2479 "CISA.y"
            {
        // Both GENERAL_VAR and SURFACE_VAR are addressable
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.regAccess).cisa_decl == nullptr)
            PARSE_ERROR("unbound variable");
        (yyval.regAccess).row = 0;
        (yyval.regAccess).elem = 0;
    }
#line 5208 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 353: /* SrcAddrOperand: AddrVarAccessWithWidth  */
#line 2490 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_set_address_operand(
                (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, false, CISAlineno));
    }
#line 5218 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 354: /* SrcGeneralOperand: Var TwoDimOffset SrcRegionDirect  */
#line 2498 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 5228 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 355: /* SrcGeneralOperand: SrcModifier Var TwoDimOffset SrcRegionDirect  */
#line 2505 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (yyvsp[-3].src_mod).mod, CISAlineno));
    }
#line 5238 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 356: /* SrcImmOperand: IntExpUnr DataTypeIntOrVector  */
#line 2515 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed((yyvsp[-1].intval), (yyvsp[0].type), CISAlineno);
    }
#line 5246 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 357: /* SrcImmOperand: HEX_LIT HFTYPE  */
#line 2520 "CISA.y"
                     {
        MUST_HOLD((yyvsp[-1].intval) < 0x10000, "literal too large for half float");
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed(
            (unsigned short)(yyvsp[-1].intval), ISA_TYPE_HF, CISAlineno);
    }
#line 5256 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 358: /* SrcImmOperand: FloatLit  */
#line 2528 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 5264 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 359: /* SrcImmOperand: MINUS FloatLit  */
#line 2531 "CISA.y"
                     {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 5272 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 360: /* SrcImmOperand: DoubleFloatLit  */
#line 2537 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 5280 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 361: /* SrcImmOperand: MINUS DoubleFloatLit  */
#line 2541 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 5288 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 363: /* FloatLit: DEC_LIT FTYPE  */
#line 2548 "CISA.y"
   {
        // "1:f" means 1.4e-45
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 5299 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 364: /* FloatLit: HEX_LIT FTYPE  */
#line 2555 "CISA.y"
   {
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 5309 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 366: /* DoubleFloatLit: DEC_LIT DFTYPE  */
#line 2563 "CISA.y"
                    {
        // "1:df" means 5e-324
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 5320 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 367: /* DoubleFloatLit: HEX_LIT DFTYPE  */
#line 2569 "CISA.y"
                    {
        // to support 0x7ff0000000000000:df
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 5331 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 368: /* SrcIndirectOperand: IndirectVarAccess SrcRegionIndirect DataType  */
#line 2580 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 5342 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 369: /* SrcIndirectOperand: SrcModifier IndirectVarAccess SrcRegionIndirect DataType  */
#line 2588 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, (yyvsp[-3].src_mod).mod, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 5353 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 370: /* DstRegion: LANGLE IntExpNRA RANGLE  */
#line 2597 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "Dst HorzStride must be 0, 1, 2, or 4");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5363 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 371: /* SrcRegionDirect: LANGLE IntExp SEMI IntExp COMMA IntExpNRA RANGLE  */
#line 2615 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-5].intval) == 0 || (yyvsp[-5].intval) == 1 || (yyvsp[-5].intval) == 2 || (yyvsp[-5].intval) == 4 || (yyvsp[-5].intval) == 8 || (yyvsp[-5].intval) == 16 || (yyvsp[-5].intval) == 32),
                 "Src Region VertStride must be 0, 1, 2, 4, 8, 16, or 32");
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Src Region Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "Src Region HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = (unsigned)(yyvsp[-5].intval);
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5379 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 373: /* SrcRegionIndirect: LANGLE IntExp COMMA DEC_LIT RANGLE  */
#line 2632 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5393 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 374: /* SrcRegionIndirect: LANGLE IntExpNRA RANGLE  */
#line 2643 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = -1;
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5405 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 375: /* IndirectVarAccess: IND_LBRACK AddrVarAccess COMMA IntExp RBRACK  */
#line 2653 "CISA.y"
                                                 {
        (yyval.regAccess) = (yyvsp[-3].regAccess);
        (yyval.regAccess).immOff = (int)(yyvsp[-1].intval);
    }
#line 5414 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 376: /* IndirectVarAccess: IND_LBRACK AddrVarAccess RBRACK  */
#line 2658 "CISA.y"
                                                 {
          (yyval.regAccess) = (yyvsp[-1].regAccess);
          (yyval.regAccess).immOff = 0;
    }
#line 5423 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 377: /* TwoDimOffset: LPAREN IntExp COMMA IntExp RPAREN  */
#line 2663 "CISA.y"
                                                {
        MUST_HOLD((yyvsp[-3].intval) >= 0, "row (register) offset must be positive");
        (yyval.offset).row = (int)(yyvsp[-3].intval);
        MUST_HOLD((yyvsp[-1].intval) >= 0 && (yyvsp[-1].intval) <= 0xFFFF, "sub-register offset out of bounds");
        (yyval.offset).elem = (int)(yyvsp[-1].intval);
    }
#line 5434 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 378: /* PredVar: Var  */
#line 2671 "CISA.y"
        {
        (yyval.vISADecl) = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.vISADecl) == nullptr)
            PARSE_ERROR((yyvsp[0].string), ": undefined predicate variable");
        if ((yyval.vISADecl)->type != PREDICATE_VAR)
            PARSE_ERROR((yyvsp[0].string), ": not a predicate variable");
    }
#line 5446 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 379: /* AddrVarAccess: Var LPAREN IntExp RPAREN  */
#line 2680 "CISA.y"
                             {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-3].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-3].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-3].string), ": not an address variable");
        }
        (yyval.regAccess).row = 1;
        (yyval.regAccess).elem = (int)(yyvsp[-1].intval);
    }
#line 5461 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 380: /* AddrVarAccessWithWidth: Var LPAREN IntExp RPAREN LANGLE IntExpNRA RANGLE  */
#line 2692 "CISA.y"
                                                     {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-6].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-6].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-6].string), ": not an address variable");
        }
        (yyval.regAccess).row = (int)(yyvsp[-1].intval);
        (yyval.regAccess).elem = (int)(yyvsp[-4].intval);
    }
#line 5476 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 381: /* SIMDMode: %empty  */
#line 2706 "CISA.y"
           {(yyval.intval) = 0;}
#line 5482 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 382: /* SIMDMode: LPAREN DEC_LIT RPAREN  */
#line 2709 "CISA.y"
    {
       MUST_HOLD(((yyvsp[-1].intval) == 8 || (yyvsp[-1].intval) == 16 || (yyvsp[-1].intval) == 32),
                 "SIMD mode can only be 8, 16, or 32");
       (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5492 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 383: /* ElemNum: DOT DEC_LIT  */
#line 2720 "CISA.y"
    {
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 5500 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 384: /* ExecSize: LPAREN ExecSizeInt RPAREN  */
#line 2732 "CISA.y"
    {
        (yyval.emask_exec_size).emask = vISA_EMASK_M1;
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 5509 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 385: /* ExecSize: LPAREN Var COMMA ExecSizeInt RPAREN  */
#line 2738 "CISA.y"
    {
        if (!ParseEMask((yyvsp[-3].string), (yyval.emask_exec_size).emask)) {
            PARSE_ERROR("invalid execution offset info");
        }
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 5520 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 386: /* ExecSizeInt: DEC_LIT  */
#line 2746 "CISA.y"
    {
        if ((yyvsp[0].intval) != 1 && (yyvsp[0].intval) != 2 && (yyvsp[0].intval) != 4 && (yyvsp[0].intval) != 8 && (yyvsp[0].intval) != 16 && (yyvsp[0].intval) != 32) {
            PARSE_ERROR("invalid execution size");
        }
        (yyval.intval) = (unsigned short)(yyvsp[0].intval);
    }
#line 5531 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 392: /* IntExpCond: IntExpAND QUESTION IntExpAND COLON IntExpCond  */
#line 2760 "CISA.y"
                                                    {(yyval.intval) = (yyvsp[-4].intval) ? (yyvsp[-2].intval) : (yyvsp[0].intval);}
#line 5537 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 394: /* IntExpAND: IntExpAND AMP IntExpXOR  */
#line 2763 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) & (yyvsp[0].intval);}
#line 5543 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 396: /* IntExpXOR: IntExpXOR CIRC IntExpOR  */
#line 2766 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) ^ (yyvsp[0].intval);}
#line 5549 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 398: /* IntExpOR: IntExpOR PIPE IntExpCmp  */
#line 2769 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) | (yyvsp[0].intval);}
#line 5555 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 400: /* IntExpCmp: IntExpRel EQ IntExpRel  */
#line 2772 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) == (yyvsp[0].intval);}
#line 5561 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 401: /* IntExpCmp: IntExpRel NEQ IntExpRel  */
#line 2773 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) != (yyvsp[0].intval);}
#line 5567 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 403: /* IntExpRel: IntExpNRA LANGLE IntExpNRA  */
#line 2776 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) < (yyvsp[0].intval);}
#line 5573 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 404: /* IntExpRel: IntExpNRA RANGLE IntExpNRA  */
#line 2777 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) > (yyvsp[0].intval);}
#line 5579 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 405: /* IntExpRel: IntExpNRA LEQ IntExpNRA  */
#line 2778 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) <= (yyvsp[0].intval);}
#line 5585 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 406: /* IntExpRel: IntExpNRA GEQ IntExpNRA  */
#line 2779 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) >= (yyvsp[0].intval);}
#line 5591 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 409: /* IntExpShift: IntExpAdd SHL IntExpAdd  */
#line 2800 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) << (yyvsp[0].intval);}
#line 5597 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 410: /* IntExpShift: IntExpAdd SHRS IntExpAdd  */
#line 2801 "CISA.y"
                               {(yyval.intval) = (int64_t)(yyvsp[-2].intval) >> (int)(yyvsp[0].intval);}
#line 5603 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 411: /* IntExpShift: IntExpAdd SHRZ IntExpAdd  */
#line 2802 "CISA.y"
                               {(yyval.intval) = (int64_t)((uint64_t)(yyvsp[-2].intval) >> (uint64_t)(yyvsp[0].intval));}
#line 5609 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 413: /* IntExpAdd: IntExpAdd PLUS IntExpMul  */
#line 2805 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) + (yyvsp[0].intval);}
#line 5615 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 414: /* IntExpAdd: IntExpAdd MINUS IntExpMul  */
#line 2806 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) - (yyvsp[0].intval);}
#line 5621 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 416: /* IntExpMul: IntExpMul TIMES IntExpUnr  */
#line 2809 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) * (yyvsp[0].intval);}
#line 5627 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 417: /* IntExpMul: IntExpMul SLASH IntExpUnr  */
#line 2810 "CISA.y"
                                {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) / (yyvsp[0].intval);
        }
#line 5637 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 418: /* IntExpMul: IntExpMul PERCENT IntExpUnr  */
#line 2815 "CISA.y"
                                  {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) % (yyvsp[0].intval);
        }
#line 5647 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 420: /* IntExpUnr: MINUS IntExpUnr  */
#line 2822 "CISA.y"
                      {(yyval.intval) = -(yyvsp[0].intval);}
#line 5653 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 421: /* IntExpUnr: TILDE IntExpUnr  */
#line 2823 "CISA.y"
                      {(yyval.intval) = ~(yyvsp[0].intval);}
#line 5659 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 422: /* IntExpUnr: BANG IntExpUnr  */
#line 2824 "CISA.y"
                      {(yyval.intval) = !((yyvsp[0].intval));}
#line 5665 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 426: /* IntExpPrim: LPAREN IntExp RPAREN  */
#line 2832 "CISA.y"
                           {(yyval.intval) = (yyvsp[-1].intval);}
#line 5671 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 427: /* IntExpPrim: BUILTIN_SIZEOF IDENT  */
#line 2836 "CISA.y"
                           {
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[0].string), (yyval.intval)));
    }
#line 5680 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 428: /* IntExpPrim: BUILTIN_SIZEOF LPAREN IDENT RPAREN  */
#line 2840 "CISA.y"
                                         {
        // TODO: %AlignOf(...), %Max(..)
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), (yyval.intval)));
    }
#line 5690 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 429: /* IntExpPrim: BUILTIN_DISPATCH_SIMD_SIZE  */
#line 2846 "CISA.y"
                                 {
        // e.g. %DispatchSimdSize
        // N.B. %sizeof happens above
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_lookup_builtin_constant(CISAlineno, "%DispatchSimd", (yyval.intval)));
    }
#line 5701 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;


#line 5705 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.10713/redhat-linux-build/IGC/visa/CISA.tab.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (pBuilder, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, pBuilder);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, pBuilder);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (pBuilder, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, pBuilder);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, pBuilder);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 2864 "CISA.y"

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                        Utility Functions                                  //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

void CISAerror(CISA_IR_Builder* pBuilder, char const *s)
{
    pBuilder->RecordParseError(CISAlineno, s);
}

static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value)
{
    if (strcmp(sym, "byte") == 0) {
        value = ALIGN_BYTE;
    } else if (strcmp(sym, "word") == 0) {
        value = ALIGN_WORD;
    } else if (strcmp(sym, "dword") == 0) {
        value = ALIGN_DWORD;
    } else if (strcmp(sym, "qword") == 0) {
        value = ALIGN_QWORD;
    } else if (strcmp(sym, "oword") == 0) {
        value = ALIGN_OWORD;
    } else if (strcmp(sym, "GRF") == 0) {
        value = ALIGN_GRF;
    } else if (strcmp(sym, "GRFx2") == 0 || strcmp(sym, "2GRF") == 0) {
        value = ALIGN_2_GRF;
    } else if (strcmp(sym, "hword") == 0) {
        value = ALIGN_HWORD;
    } else if (strcmp(sym, "wordx32") == 0) {
        value = ALIGN_32WORD;
    } else if (strcmp(sym, "wordx64") == 0) {
        value = ALIGN_64WORD;
    } else {
        value = ALIGN_UNDEF;
        return false;
    }
    return true;
}


static VISA_Align AlignBytesToVisaAlignment(int bytes)
{
    VISA_Align val = ALIGN_UNDEF;
    switch (bytes) {
    case 1:   val = ALIGN_BYTE; break;
    case 2:   val = ALIGN_WORD; break;
    case 4:   val = ALIGN_DWORD; break;
    case 8:   val = ALIGN_QWORD; break;
    case 16:  val = ALIGN_OWORD; break;
    case 32:  val = ALIGN_HWORD; break;
    case 64:  val = ALIGN_32WORD; break;
    case 128: val = ALIGN_64WORD; break;
    default:  val = ALIGN_UNDEF; break;
    }
    return val;
}



static bool ParseEMask(
    const char* sym,
    VISA_EMask_Ctrl &emask)
{
    if (strcmp(sym, "NoMask") == 0) {
        emask = vISA_EMASK_M1_NM;
        return true;
    }
    for (int i = 0; i < vISA_NUM_EMASK +1; i++)
    {
        if (!strcmp(emask_str[i], sym))
        {
            emask = (VISA_EMask_Ctrl)i;
            return true;
        }
    }

    emask = vISA_NUM_EMASK;
    return false;
}

static int lscCheckExecSize(
    CISA_IR_Builder* pBuilder,
    LSC_SFID sfid,
    LSC_OP op,
    LSC_DATA_ORDER data_order,
    int exec_size)
{
    int is_vector_op =
        op != LSC_LOAD_BLOCK2D &&
        op != LSC_STORE_BLOCK2D;
        // other ops like LSC_LOAD_SURFACE_INFO may be SIMD1
    if (op == LSC_READ_STATE_INFO) {
        exec_size = 1;
    } else if (data_order == LSC_DATA_ORDER_NONTRANSPOSE && is_vector_op) {
        if (exec_size == UNDEFINED_EXEC_SIZE) {
            if (pBuilder->getPlatform() == Xe_DG2) // for DG2 typed is 8, untyped is 16
                exec_size = sfid == LSC_TGM ? 8 : 16;
            else if (pBuilder->getPlatform() >= Xe_PVC) // on PVC typed is 16, untyped is 32
                exec_size = sfid == LSC_TGM ? 16 : 32;
            else
                exec_size = 32; // the world is finally sane
        }
    } else {
        // block and transpose get SIMD by default
        if (exec_size == UNDEFINED_EXEC_SIZE) {
           exec_size = 1; // transpose is implicitly 1 if needed
        }
    }
    return exec_size;
}
